pub mod Array_ {
    use super::*;
    use crate::module_2031347a::Native_::array;
    use crate::module_2031347a::Native_::arrayCopy;
    use crate::module_2031347a::Native_::arrayCreate;
    use crate::module_2031347a::Native_::arrayEmpty;
    use crate::module_2031347a::Native_::arrayWithCapacity;
    use crate::module_2031347a::Native_::comparer as comparer_1;
    use crate::module_2031347a::Native_::defaultOf;
    use crate::module_2031347a::Native_::getZero;
    use crate::module_2031347a::Native_::Array;
    use crate::module_2031347a::Native_::Lrc;
    use crate::module_2031347a::Native_::MutCell;
    use crate::module_25e675f8::Option_::defaultArg;
    use crate::module_25e675f8::Option_::getValue;
    use crate::module_912d02ed::Interfaces_::System::Collections::Generic::IEnumerable_1;
    use crate::module_982cddd5::HashMap_::add;
    use crate::module_982cddd5::HashMap_::empty as empty_1;
    use crate::module_982cddd5::HashMap_::get;
    use crate::module_982cddd5::HashMap_::set;
    use crate::module_982cddd5::HashMap_::tryGetValue;
    use crate::module_982cddd5::HashMap_::HashMap;
    use crate::module_9d52c5fc::Seq_::toArray;
    use crate::module_a61cad0b::HashSet_::empty;
    use crate::module_a61cad0b::HashSet_::fromArray;
    use crate::module_a61cad0b::HashSet_::HashSet;
    use crate::module_b1128850::Global_::SR;
    use crate::module_c5a2a64e::String_::append as append_1;
    use crate::module_c5a2a64e::String_::string;
    use crate::module_d98fc69f::Util_::compare;
    pub fn tryItem<T: Clone + 'static>(index: i32, source: Array<T>) -> Option<T> {
        if if index < 0i32 {
            true
        } else {
            index >= source.len() as i32
        } {
            None::<T>
        } else {
            Some(source[index].clone())
        }
    }
    pub fn reverse<T: Clone + 'static>(source: Array<T>) -> Array<T> {
        let res: Array<T> = arrayCopy(source);
        res.clone().get_mut().reverse();
        res
    }
    pub fn fill<T: Clone + 'static>(target: Array<T>, targetIndex: i32, count: i32, value: T) {
        if if targetIndex < 0i32 {
            true
        } else {
            targetIndex + count > target.len() as i32
        } {
            panic!(
                "{}",
                append_1(
                    append_1(SR::indexOutOfBounds(), string("\\nParameter name: ")),
                    string("index")
                )
            );
        }
        {
            let len: i32 = target.len() as i32;
            for i in targetIndex..=targetIndex + count - 1i32 {
                target.get_mut()[i as usize] = value.clone();
            }
        }
    }
    pub fn getSubArray<T: Clone + 'static>(
        source: Array<T>,
        startIndex: i32,
        count: i32,
    ) -> Array<T> {
        if if startIndex < 0i32 {
            true
        } else {
            startIndex + count > source.len() as i32
        } {
            panic!(
                "{}",
                append_1(
                    append_1(SR::indexOutOfBounds(), string("\\nParameter name: ")),
                    string("index")
                )
            );
        }
        {
            let res: Array<T> = arrayWithCapacity::<T>(count);
            for i in 0i32..=count - 1i32 {
                res.get_mut().push(source[startIndex + i].clone());
            }
            (&res).clone()
        }
    }
    pub fn exactlyOne<T: Clone + 'static>(source: Array<T>) -> T {
        if source.len() as i32 == 1i32 {
            source[0i32].clone()
        } else {
            if source.is_empty() {
                panic!(
                    "{}",
                    append_1(
                        append_1(SR::inputSequenceEmpty(), string("\\nParameter name: ")),
                        string("array")
                    )
                )
            } else {
                panic!(
                    "{}",
                    append_1(
                        append_1(SR::inputSequenceTooLong(), string("\\nParameter name: ")),
                        string("array")
                    )
                )
            }
        }
    }
    pub fn tryExactlyOne<T: Clone + 'static>(source: Array<T>) -> Option<T> {
        if source.len() as i32 == 1i32 {
            Some(source[0i32].clone())
        } else {
            None::<T>
        }
    }
    pub fn head<T: Clone + 'static>(source: Array<T>) -> T {
        if source.is_empty() {
            panic!(
                "{}",
                append_1(
                    append_1(SR::arrayWasEmpty(), string("\\nParameter name: ")),
                    string("array")
                )
            )
        } else {
            source[0i32].clone()
        }
    }
    pub fn tryHead<T: Clone + 'static>(source: Array<T>) -> Option<T> {
        if source.is_empty() {
            None::<T>
        } else {
            Some(source[0i32].clone())
        }
    }
    pub fn last<T: Clone + 'static>(source: Array<T>) -> T {
        if source.is_empty() {
            panic!(
                "{}",
                append_1(
                    append_1(SR::arrayWasEmpty(), string("\\nParameter name: ")),
                    string("array")
                )
            )
        } else {
            source[source.len() as i32 - 1i32].clone()
        }
    }
    pub fn tryLast<T: Clone + 'static>(source: Array<T>) -> Option<T> {
        if source.is_empty() {
            None::<T>
        } else {
            Some(source[source.len() as i32 - 1i32].clone())
        }
    }
    pub fn tail<T: Clone + 'static>(source: Array<T>) -> Array<T> {
        if source.is_empty() {
            panic!(
                "{}",
                append_1(
                    append_1(SR::notEnoughElements(), string("\\nParameter name: ")),
                    string("array")
                )
            );
        }
        Array_::getSubArray(source.clone(), 1i32, source.len() as i32 - 1i32)
    }
    pub fn append<T: Clone + 'static>(source1: Array<T>, source2: Array<T>) -> Array<T> {
        let len1: i32 = source1.len() as i32;
        let len2: i32 = source2.len() as i32;
        let res: Array<T> = arrayWithCapacity::<T>(len1 + len2);
        for i in 0i32..=len1 - 1i32 {
            res.get_mut().push(source1[i].clone());
        }
        for i_1 in 0i32..=len2 - 1i32 {
            res.get_mut().push(source2[i_1].clone());
        }
        (&res).clone()
    }
    pub fn choose<T: Clone + 'static, U: Clone + 'static>(
        chooser: Lrc<dyn Fn(T) -> (Option<U>) + 'static>,
        source: Array<T>,
    ) -> Array<U> {
        let res: Array<U> = arrayEmpty::<U>();
        for i in 0i32..=source.len() as i32 - 1i32 {
            let matchValue: Option<U> = chooser(source[i].clone());
            match &matchValue {
                None => (),
                Some(matchValue_0_0) => {
                    let x: U = matchValue_0_0.clone();
                    res.get_mut().push(x.clone())
                }
            }
        }
        (&res).clone()
    }
    pub fn compareWith<T: Clone + 'static>(
        comparer: Lrc<dyn Fn(T, T) -> (i32) + 'static>,
        source1: Array<T>,
        source2: Array<T>,
    ) -> i32 {
        let len1: i32 = source1.len() as i32;
        let len2: i32 = source2.len() as i32;
        let len: i32 = if len1 < len2 { len1 } else { len2 };
        let i: MutCell<i32> = MutCell::new(0i32);
        let res: MutCell<i32> = MutCell::new(0i32);
        while if res.get() == 0i32 {
            i.get() < len
        } else {
            false
        } {
            res.set(comparer(source1[i.get()].clone(), source2[i.get()].clone()));
            i.set(i.get() + 1i32)
        }
        if !(res.get() == 0i32) {
            res.get()
        } else {
            if len1 > len2 {
                1i32
            } else {
                if len1 < len2 {
                    -1i32
                } else {
                    0i32
                }
            }
        }
    }
    pub fn compareTo<T: PartialOrd + Clone + 'static>(source1: Array<T>, source2: Array<T>) -> i32 {
        let len1: i32 = source1.len() as i32;
        let len2: i32 = source2.len() as i32;
        if len1 > len2 {
            1i32
        } else {
            if len1 < len2 {
                -1i32
            } else {
                let i: MutCell<i32> = MutCell::new(0i32);
                let res: MutCell<i32> = MutCell::new(0i32);
                while if res.get() == 0i32 {
                    i.get() < len1
                } else {
                    false
                } {
                    res.set(compare(source1[i.get()].clone(), source2[i.get()].clone()));
                    i.set(i.get() + 1i32)
                }
                res.get()
            }
        }
    }
    pub fn equals<T: Eq + core::hash::Hash + Clone + 'static>(
        source1: Array<T>,
        source2: Array<T>,
    ) -> bool {
        let len1: i32 = source1.len() as i32;
        if len1 == source2.len() as i32 {
            let i: MutCell<i32> = MutCell::new(0i32);
            let res: MutCell<bool> = MutCell::new(true);
            while if res.get() { i.get() < len1 } else { false } {
                res.set(source1[i.get()].clone() == source2[i.get()].clone());
                i.set(i.get() + 1i32)
            }
            res.get()
        } else {
            false
        }
    }
    pub fn mapIndexed<T: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<dyn Fn(i32, T) -> (U) + 'static>,
        source: Array<T>,
    ) -> Array<U> {
        let len: i32 = source.len() as i32;
        let res: Array<U> = arrayWithCapacity::<U>(len);
        for i in 0i32..=len - 1i32 {
            res.get_mut().push(mapping(i, source[i].clone()));
        }
        (&res).clone()
    }
    pub fn map<T: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<dyn Fn(T) -> (U) + 'static>,
        source: Array<T>,
    ) -> Array<U> {
        let len: i32 = source.len() as i32;
        let res: Array<U> = arrayWithCapacity::<U>(len);
        for i in 0i32..=len - 1i32 {
            res.get_mut().push(mapping(source[i].clone()));
        }
        (&res).clone()
    }
    pub fn mapIndexed2<T1: Clone + 'static, T2: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<dyn Fn(i32, T1, T2) -> (U) + 'static>,
        source1: Array<T1>,
        source2: Array<T2>,
    ) -> Array<U> {
        if !(source1.len() as i32 == source2.len() as i32) {
            panic!("{}", SR::arraysHadDifferentLengths());
        }
        {
            let len: i32 = source1.len() as i32;
            let res: Array<U> = arrayWithCapacity::<U>(len);
            for i in 0i32..=len - 1i32 {
                res.get_mut()
                    .push(mapping(i, source1[i].clone(), source2[i].clone()));
            }
            (&res).clone()
        }
    }
    pub fn map2<T1: Clone + 'static, T2: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<dyn Fn(T1, T2) -> (U) + 'static>,
        source1: Array<T1>,
        source2: Array<T2>,
    ) -> Array<U> {
        if !(source1.len() as i32 == source2.len() as i32) {
            panic!("{}", SR::arraysHadDifferentLengths());
        }
        {
            let len: i32 = source1.len() as i32;
            let res: Array<U> = arrayWithCapacity::<U>(len);
            for i in 0i32..=len - 1i32 {
                res.get_mut()
                    .push(mapping(source1[i].clone(), source2[i].clone()));
            }
            (&res).clone()
        }
    }
    pub fn map3<
        T1: Clone + 'static,
        T2: Clone + 'static,
        T3: Clone + 'static,
        U: Clone + 'static,
    >(
        mapping: Lrc<dyn Fn(T1, T2, T3) -> (U) + 'static>,
        source1: Array<T1>,
        source2: Array<T2>,
        source3: Array<T3>,
    ) -> Array<U> {
        if if !(source1.len() as i32 == source2.len() as i32) {
            true
        } else {
            !(source2.len() as i32 == source3.len() as i32)
        } {
            panic!("{}", SR::arraysHadDifferentLengths());
        }
        {
            let len: i32 = source1.len() as i32;
            let res: Array<U> = arrayWithCapacity::<U>(len);
            for i in 0i32..=len - 1i32 {
                res.get_mut().push(mapping(
                    source1[i].clone(),
                    source2[i].clone(),
                    source3[i].clone(),
                ));
            }
            (&res).clone()
        }
    }
    pub fn mapFold<State: Clone + 'static, T: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<dyn Fn(State, T) -> (Lrc<(U, State)>) + 'static>,
        state: State,
        source: Array<T>,
    ) -> Lrc<(Array<U>, State)> {
        let acc: MutCell<State> = MutCell::new(state);
        let len: i32 = source.len() as i32;
        let res: Array<U> = arrayWithCapacity::<U>(len);
        for i in 0i32..=len - 1i32 {
            let m: Lrc<(U, State)> = mapping(acc.get().clone(), source[i].clone());
            res.get_mut().push(m.0.clone());
            acc.set(m.1.clone())
        }
        Lrc::new(((&res).clone(), acc.get()))
    }
    pub fn mapFoldBack<T: Clone + 'static, State: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<dyn Fn(T, State) -> (Lrc<(U, State)>) + 'static>,
        source: Array<T>,
        state: State,
    ) -> Lrc<(Array<U>, State)> {
        let acc: MutCell<State> = MutCell::new(state);
        let len: i32 = source.len() as i32;
        let res: Array<U> = arrayWithCapacity::<U>(len);
        for i in (0i32..=len - 1i32).rev() {
            let m: Lrc<(U, State)> = mapping(source[i].clone(), acc.get().clone());
            res.get_mut().push(m.0.clone());
            acc.set(m.1.clone())
        }
        res.get_mut().reverse();
        Lrc::new(((&res).clone(), acc.get()))
    }
    pub fn indexed<T: Clone + 'static>(source: Array<T>) -> Array<Lrc<(i32, T)>> {
        let len: i32 = source.len() as i32;
        let res: Array<Lrc<(i32, T)>> = arrayWithCapacity::<Lrc<(i32, T)>>(len);
        for i in 0i32..=len - 1i32 {
            res.get_mut().push(Lrc::new((i, source[i].clone())));
        }
        (&res).clone()
    }
    pub fn concat<T: Clone + 'static>(sources: Array<Array<T>>) -> Array<T> {
        let len: MutCell<i32> = MutCell::new(0i32);
        for idx in 0i32..=sources.len() as i32 - 1i32 {
            let arr: Array<T> = sources[idx].clone();
            len.set(len.get() + arr.len() as i32)
        }
        {
            let res: Array<T> = arrayWithCapacity::<T>(len.get());
            for idx_1 in 0i32..=sources.len() as i32 - 1i32 {
                let arr_1: Array<T> = sources[idx_1].clone();
                for idx_2 in 0i32..=arr_1.len() as i32 - 1i32 {
                    let x: T = arr_1[idx_2].clone();
                    res.get_mut().push(x.clone())
                }
            }
            (&res).clone()
        }
    }
    pub fn collect<T: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<dyn Fn(T) -> (Array<U>) + 'static>,
        source: Array<T>,
    ) -> Array<U> {
        Array_::concat(Array_::map(mapping, source))
    }
    pub fn exists<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        source: Array<T>,
    ) -> bool {
        let i: MutCell<i32> = MutCell::new(0i32);
        let res: MutCell<bool> = MutCell::new(false);
        while if i.get() < source.len() as i32 {
            !res.get()
        } else {
            false
        } {
            res.set(predicate(source[i.get()].clone()));
            i.set(i.get() + 1i32)
        }
        res.get()
    }
    pub fn exists2<T1: Clone + 'static, T2: Clone + 'static>(
        predicate: Lrc<dyn Fn(T1, T2) -> (bool) + 'static>,
        source1: Array<T1>,
        source2: Array<T2>,
    ) -> bool {
        if !(source1.len() as i32 == source2.len() as i32) {
            panic!("{}", SR::arraysHadDifferentLengths());
        }
        {
            let i: MutCell<i32> = MutCell::new(0i32);
            let res: MutCell<bool> = MutCell::new(false);
            while if i.get() < source1.len() as i32 {
                !res.get()
            } else {
                false
            } {
                res.set(predicate(
                    source1[i.get()].clone(),
                    source2[i.get()].clone(),
                ));
                i.set(i.get() + 1i32)
            }
            res.get()
        }
    }
    pub fn contains<T: Eq + core::hash::Hash + Clone + 'static>(
        value: T,
        source: Array<T>,
    ) -> bool {
        Array_::exists(
            Lrc::new({
                let value = value.clone();
                move |x: T| x.clone() == value.clone()
            }),
            source,
        )
    }
    pub fn filter<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        source: Array<T>,
    ) -> Array<T> {
        let res: Array<T> = arrayEmpty::<T>();
        for i in 0i32..=source.len() as i32 - 1i32 {
            if predicate(source[i].clone()) {
                res.get_mut().push(source[i].clone());
            };
        }
        (&res).clone()
    }
    pub fn initialize<T: Clone + 'static>(
        count: i32,
        initializer: Lrc<dyn Fn(i32) -> (T) + 'static>,
    ) -> Array<T> {
        if count < 0i32 {
            panic!(
                "{}",
                append_1(
                    append_1(SR::inputMustBeNonNegative(), string("\\nParameter name: ")),
                    string("count")
                )
            );
        }
        {
            let res: Array<T> = arrayWithCapacity::<T>(count);
            for i in 0i32..=count - 1i32 {
                res.get_mut().push(initializer(i));
            }
            (&res).clone()
        }
    }
    pub fn pairwise<T: Clone + 'static>(source: Array<T>) -> Array<Lrc<(T, T)>> {
        if (source.len() as i32) < 2i32 {
            (&arrayEmpty::<Lrc<(T, T)>>()).clone()
        } else {
            let len: i32 = source.len() as i32 - 1i32;
            let res: Array<Lrc<(T, T)>> = arrayWithCapacity::<Lrc<(T, T)>>(len);
            for i in 0i32..=len - 1i32 {
                res.get_mut()
                    .push(Lrc::new((source[i].clone(), source[i + 1i32].clone())));
            }
            (&res).clone()
        }
    }
    pub fn partition<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        source: Array<T>,
    ) -> Lrc<(Array<T>, Array<T>)> {
        let res1: Array<T> = arrayEmpty::<T>();
        let res2: Array<T> = arrayEmpty::<T>();
        for i in 0i32..=source.len() as i32 - 1i32 {
            if predicate(source[i].clone()) {
                res1.get_mut().push(source[i].clone())
            } else {
                res2.get_mut().push(source[i].clone())
            };
        }
        Lrc::new(((&res1).clone(), (&res2).clone()))
    }
    pub fn reduce<T: Clone + 'static>(
        reduction: Lrc<dyn Fn(T, T) -> (T) + 'static>,
        source: Array<T>,
    ) -> T {
        if source.is_empty() {
            panic!("{}", SR::arrayWasEmpty());
        }
        {
            let folder = Lrc::new({
                let reduction = reduction.clone();
                move |i: i32, acc: T, x: T| {
                    if i == 0i32 {
                        x.clone()
                    } else {
                        reduction(acc.clone(), x.clone())
                    }
                }
            });
            let acc_1: MutCell<T> = MutCell::new(source[0i32].clone());
            for i_1 in 0i32..=source.len() as i32 - 1i32 {
                acc_1.set(folder(i_1, acc_1.get().clone(), source[i_1].clone()));
            }
            acc_1.get()
        }
    }
    pub fn reduceBack<T: Clone + 'static>(
        reduction: Lrc<dyn Fn(T, T) -> (T) + 'static>,
        source: Array<T>,
    ) -> T {
        if source.is_empty() {
            panic!("{}", SR::arrayWasEmpty());
        }
        {
            let folder = Lrc::new({
                let reduction = reduction.clone();
                move |i: i32, x: T, acc: T| {
                    if i == 0i32 {
                        x.clone()
                    } else {
                        reduction(acc.clone(), x.clone())
                    }
                }
            });
            let len: i32 = source.len() as i32;
            let acc_1: MutCell<T> = MutCell::new(source[len - 1i32].clone());
            for i_1 in 1i32..=len {
                acc_1.set(folder(
                    i_1 - 1i32,
                    source[len - i_1].clone(),
                    acc_1.get().clone(),
                ));
            }
            acc_1.get()
        }
    }
    pub fn replicate<T: Clone + 'static>(count: i32, initial: T) -> Array<T> {
        Array_::initialize(
            count,
            Lrc::new({
                let initial = initial.clone();
                move |_arg: i32| initial.clone()
            }),
        )
    }
    pub fn scan<State: Clone + 'static, T: Clone + 'static>(
        folder: Lrc<dyn Fn(State, T) -> (State) + 'static>,
        state: State,
        source: Array<T>,
    ) -> Array<State> {
        let len: i32 = source.len() as i32;
        let res: Array<State> = arrayCreate(&(len + 1i32), &state);
        res.get_mut()[0i32 as usize] = state.clone();
        for i in 0i32..=len - 1i32 {
            res.get_mut()[(i + 1i32) as usize] = folder(res[i].clone(), source[i].clone());
        }
        res.clone()
    }
    pub fn scanBack<T: Clone + 'static, State: Clone + 'static>(
        folder: Lrc<dyn Fn(T, State) -> (State) + 'static>,
        source: Array<T>,
        state: State,
    ) -> Array<State> {
        let len: i32 = source.len() as i32;
        let res: Array<State> = arrayCreate(&(len + 1i32), &state);
        res.get_mut()[len as usize] = state.clone();
        for i in (0i32..=len - 1i32).rev() {
            res.get_mut()[i as usize] = folder(source[i].clone(), res[i + 1i32].clone());
        }
        res.clone()
    }
    pub fn skip<T: Clone + 'static>(count: i32, source: Array<T>) -> Array<T> {
        if count > source.len() as i32 {
            panic!(
                "{}",
                append_1(
                    append_1(SR::outOfRange(), string("\\nParameter name: ")),
                    string("count")
                )
            );
        }
        {
            let count_1: i32 = if count < 0i32 { 0i32 } else { count };
            Array_::getSubArray(source.clone(), count_1, source.len() as i32 - count_1)
        }
    }
    pub fn skipWhile<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        source: Array<T>,
    ) -> Array<T> {
        let count: MutCell<i32> = MutCell::new(0i32);
        while if count.get() < source.len() as i32 {
            predicate(source[count.get()].clone())
        } else {
            false
        } {
            count.set(count.get() + 1i32);
        }
        Array_::getSubArray(
            source.clone(),
            count.get(),
            source.len() as i32 - count.get(),
        )
    }
    pub fn take<T: Clone + 'static>(count: i32, source: Array<T>) -> Array<T> {
        if count < 0i32 {
            panic!(
                "{}",
                append_1(
                    append_1(SR::inputMustBeNonNegative(), string("\\nParameter name: ")),
                    string("count")
                )
            );
        }
        if count > source.len() as i32 {
            panic!(
                "{}",
                append_1(
                    append_1(SR::notEnoughElements(), string("\\nParameter name: ")),
                    string("array")
                )
            );
        }
        Array_::getSubArray(source, 0i32, count)
    }
    pub fn takeWhile<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        source: Array<T>,
    ) -> Array<T> {
        let count: MutCell<i32> = MutCell::new(0i32);
        while if count.get() < source.len() as i32 {
            predicate(source[count.get()].clone())
        } else {
            false
        } {
            count.set(count.get() + 1i32);
        }
        Array_::getSubArray(source, 0i32, count.get())
    }
    pub fn truncate<T: Clone + 'static>(count: i32, source: Array<T>) -> Array<T> {
        Array_::getSubArray(
            source.clone(),
            0i32,
            if count < 0i32 {
                0i32
            } else {
                if count > source.len() as i32 {
                    source.len() as i32
                } else {
                    count
                }
            },
        )
    }
    pub fn copyTo<T: Clone + 'static>(
        source: Array<T>,
        sourceIndex: i32,
        target: Array<T>,
        targetIndex: i32,
        count: i32,
    ) {
        let diff: i32 = targetIndex - sourceIndex;
        for i in sourceIndex..=sourceIndex + count - 1i32 {
            target.get_mut()[(i + diff) as usize] = source[i].clone();
        }
    }
    pub fn tryFind<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        source: Array<T>,
    ) -> Option<T> {
        fn inner_loop<T: Clone + 'static>(
            i: i32,
            predicate_1: Lrc<dyn Fn(T) -> (bool) + 'static>,
            source_1: Array<T>,
        ) -> Option<T> {
            let i: MutCell<i32> = MutCell::new(i);
            let predicate_1 = MutCell::new(predicate_1.clone());
            let source_1: MutCell<Array<T>> = MutCell::new(source_1.clone());
            '_inner_loop: loop {
                break '_inner_loop (if i.get() >= source_1.get().len() as i32 {
                    None::<T>
                } else {
                    if predicate_1(source_1[i.get()].clone()) {
                        Some(source_1[i.get()].clone())
                    } else {
                        let i_temp: i32 = i.get() + 1i32;
                        let predicate_1_temp = predicate_1.get();
                        let source_1_temp: Array<T> = source_1.get();
                        i.set(i_temp);
                        predicate_1.set(predicate_1_temp);
                        source_1.set(source_1_temp);
                        continue '_inner_loop;
                    }
                });
            }
        }
        inner_loop(0i32, predicate, source)
    }
    pub fn find<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        source: Array<T>,
    ) -> T {
        let matchValue: Option<T> = Array_::tryFind(predicate, source);
        match &matchValue {
            None => panic!("{}", SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn tryFindIndex<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        source: Array<T>,
    ) -> Option<i32> {
        fn inner_loop<T: Clone + 'static>(
            i: i32,
            predicate_1: Lrc<dyn Fn(T) -> (bool) + 'static>,
            source_1: Array<T>,
        ) -> Option<i32> {
            let i: MutCell<i32> = MutCell::new(i);
            let predicate_1 = MutCell::new(predicate_1.clone());
            let source_1: MutCell<Array<T>> = MutCell::new(source_1.clone());
            '_inner_loop: loop {
                break '_inner_loop (if i.get() >= source_1.get().len() as i32 {
                    None::<i32>
                } else {
                    if predicate_1(source_1[i.get()].clone()) {
                        Some(i.get())
                    } else {
                        let i_temp: i32 = i.get() + 1i32;
                        let predicate_1_temp = predicate_1.get();
                        let source_1_temp: Array<T> = source_1.get();
                        i.set(i_temp);
                        predicate_1.set(predicate_1_temp);
                        source_1.set(source_1_temp);
                        continue '_inner_loop;
                    }
                });
            }
        }
        inner_loop(0i32, predicate, source)
    }
    pub fn findIndex<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        source: Array<T>,
    ) -> i32 {
        let matchValue: Option<i32> = Array_::tryFindIndex(predicate, source);
        match &matchValue {
            None => panic!("{}", SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn indexOf<T: Eq + core::hash::Hash + Clone + 'static>(source: Array<T>, item: T) -> i32 {
        let matchValue: Option<i32> = Array_::tryFindIndex(
            Lrc::new({
                let item = item.clone();
                move |x: T| x.clone() == item.clone()
            }),
            source,
        );
        match &matchValue {
            None => -1i32,
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn tryFindBack<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        source: Array<T>,
    ) -> Option<T> {
        fn inner_loop<T: Clone + 'static>(
            i: i32,
            predicate_1: Lrc<dyn Fn(T) -> (bool) + 'static>,
            source_1: Array<T>,
        ) -> Option<T> {
            let i: MutCell<i32> = MutCell::new(i);
            let predicate_1 = MutCell::new(predicate_1.clone());
            let source_1: MutCell<Array<T>> = MutCell::new(source_1.clone());
            '_inner_loop: loop {
                break '_inner_loop (if i.get() < 0i32 {
                    None::<T>
                } else {
                    if predicate_1(source_1[i.get()].clone()) {
                        Some(source_1[i.get()].clone())
                    } else {
                        let i_temp: i32 = i.get() - 1i32;
                        let predicate_1_temp = predicate_1.get();
                        let source_1_temp: Array<T> = source_1.get();
                        i.set(i_temp);
                        predicate_1.set(predicate_1_temp);
                        source_1.set(source_1_temp);
                        continue '_inner_loop;
                    }
                });
            }
        }
        inner_loop(source.len() as i32 - 1i32, predicate, source)
    }
    pub fn findBack<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        source: Array<T>,
    ) -> T {
        let matchValue: Option<T> = Array_::tryFindBack(predicate, source);
        match &matchValue {
            None => panic!("{}", SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn tryFindIndexBack<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        source: Array<T>,
    ) -> Option<i32> {
        fn inner_loop<T: Clone + 'static>(
            i: i32,
            predicate_1: Lrc<dyn Fn(T) -> (bool) + 'static>,
            source_1: Array<T>,
        ) -> Option<i32> {
            let i: MutCell<i32> = MutCell::new(i);
            let predicate_1 = MutCell::new(predicate_1.clone());
            let source_1: MutCell<Array<T>> = MutCell::new(source_1.clone());
            '_inner_loop: loop {
                break '_inner_loop (if i.get() < 0i32 {
                    None::<i32>
                } else {
                    if predicate_1(source_1[i.get()].clone()) {
                        Some(i.get())
                    } else {
                        let i_temp: i32 = i.get() - 1i32;
                        let predicate_1_temp = predicate_1.get();
                        let source_1_temp: Array<T> = source_1.get();
                        i.set(i_temp);
                        predicate_1.set(predicate_1_temp);
                        source_1.set(source_1_temp);
                        continue '_inner_loop;
                    }
                });
            }
        }
        inner_loop(source.len() as i32 - 1i32, predicate, source)
    }
    pub fn findIndexBack<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        source: Array<T>,
    ) -> i32 {
        let matchValue: Option<i32> = Array_::tryFindIndexBack(predicate, source);
        match &matchValue {
            None => panic!("{}", SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn findLastIndex<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        source: Array<T>,
    ) -> i32 {
        let matchValue: Option<i32> = Array_::tryFindIndexBack(predicate, source);
        match &matchValue {
            None => -1i32,
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn tryPick<T: Clone + 'static, U: Clone + 'static>(
        chooser: Lrc<dyn Fn(T) -> (Option<U>) + 'static>,
        source: Array<T>,
    ) -> Option<U> {
        fn inner_loop<T: Clone + 'static, U: Clone + 'static>(
            i: i32,
            chooser_1: Lrc<dyn Fn(T) -> (Option<U>) + 'static>,
            source_1: Array<T>,
        ) -> Option<U> {
            let i: MutCell<i32> = MutCell::new(i);
            let chooser_1 = MutCell::new(chooser_1.clone());
            let source_1: MutCell<Array<T>> = MutCell::new(source_1.clone());
            '_inner_loop: loop {
                break '_inner_loop (if i.get() >= source_1.get().len() as i32 {
                    None::<U>
                } else {
                    let matchValue: Option<U> = chooser_1(source_1[i.get()].clone());
                    if matchValue.is_none() {
                        let i_temp: i32 = i.get() + 1i32;
                        let chooser_1_temp = chooser_1.get();
                        let source_1_temp: Array<T> = source_1.get();
                        i.set(i_temp);
                        chooser_1.set(chooser_1_temp);
                        source_1.set(source_1_temp);
                        continue '_inner_loop;
                    } else {
                        matchValue.clone()
                    }
                });
            }
        }
        inner_loop(0i32, chooser, source)
    }
    pub fn pick<T: Clone + 'static, U: Clone + 'static>(
        chooser: Lrc<dyn Fn(T) -> (Option<U>) + 'static>,
        source: Array<T>,
    ) -> U {
        let matchValue: Option<U> = Array_::tryPick(chooser, source);
        match &matchValue {
            None => panic!("{}", SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn fold<State: Clone + 'static, T: Clone + 'static>(
        folder: Lrc<dyn Fn(State, T) -> (State) + 'static>,
        state: State,
        source: Array<T>,
    ) -> State {
        let acc: MutCell<State> = MutCell::new(state);
        for i in 0i32..=source.len() as i32 - 1i32 {
            acc.set(folder(acc.get().clone(), source[i].clone()));
        }
        acc.get()
    }
    pub fn foldBack<T: Clone + 'static, State: Clone + 'static>(
        folder: Lrc<dyn Fn(T, State) -> (State) + 'static>,
        source: Array<T>,
        state: State,
    ) -> State {
        let acc: MutCell<State> = MutCell::new(state);
        let len: i32 = source.len() as i32;
        for i in 1i32..=len {
            acc.set(folder(source[len - i].clone(), acc.get().clone()));
        }
        acc.get()
    }
    pub fn fold2<State: Clone + 'static, T1: Clone + 'static, T2: Clone + 'static>(
        folder: Lrc<dyn Fn(State, T1, T2) -> (State) + 'static>,
        state: State,
        source1: Array<T1>,
        source2: Array<T2>,
    ) -> State {
        let acc: MutCell<State> = MutCell::new(state);
        if !(source1.len() as i32 == source2.len() as i32) {
            panic!("{}", SR::arraysHadDifferentLengths());
        }
        for i in 0i32..=source1.len() as i32 - 1i32 {
            acc.set(folder(
                acc.get().clone(),
                source1[i].clone(),
                source2[i].clone(),
            ));
        }
        acc.get()
    }
    pub fn foldBack2<T1: Clone + 'static, T2: Clone + 'static, State: Clone + 'static>(
        folder: Lrc<dyn Fn(T1, T2, State) -> (State) + 'static>,
        source1: Array<T1>,
        source2: Array<T2>,
        state: State,
    ) -> State {
        let acc: MutCell<State> = MutCell::new(state);
        if !(source1.len() as i32 == source2.len() as i32) {
            panic!("{}", SR::arraysHadDifferentLengths());
        }
        {
            let len: i32 = source1.len() as i32;
            for i in 1i32..=len {
                acc.set(folder(
                    source1[len - i].clone(),
                    source2[len - i].clone(),
                    acc.get().clone(),
                ));
            }
            acc.get()
        }
    }
    pub fn forAll<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        source: Array<T>,
    ) -> bool {
        let i: MutCell<i32> = MutCell::new(0i32);
        let res: MutCell<bool> = MutCell::new(true);
        while if i.get() < source.len() as i32 {
            res.get()
        } else {
            false
        } {
            res.set(predicate(source[i.get()].clone()));
            i.set(i.get() + 1i32)
        }
        res.get()
    }
    pub fn forAll2<T1: Clone + 'static, T2: Clone + 'static>(
        predicate: Lrc<dyn Fn(T1, T2) -> (bool) + 'static>,
        source1: Array<T1>,
        source2: Array<T2>,
    ) -> bool {
        if !(source1.len() as i32 == source2.len() as i32) {
            panic!("{}", SR::arraysHadDifferentLengths());
        }
        {
            let i: MutCell<i32> = MutCell::new(0i32);
            let res: MutCell<bool> = MutCell::new(true);
            while if i.get() < source1.len() as i32 {
                res.get()
            } else {
                false
            } {
                res.set(predicate(
                    source1[i.get()].clone(),
                    source2[i.get()].clone(),
                ));
                i.set(i.get() + 1i32)
            }
            res.get()
        }
    }
    pub fn iterate<T: Clone + 'static>(action: Lrc<dyn Fn(T) + 'static>, source: Array<T>) {
        for i in 0i32..=source.len() as i32 - 1i32 {
            action(source[i].clone());
        }
    }
    pub fn iterateIndexed<T: Clone + 'static>(
        action: Lrc<dyn Fn(i32, T) + 'static>,
        source: Array<T>,
    ) {
        for i in 0i32..=source.len() as i32 - 1i32 {
            action(i, source[i].clone());
        }
    }
    pub fn iterate2<T: Clone + 'static>(
        action: Lrc<dyn Fn(T, T) + 'static>,
        source1: Array<T>,
        source2: Array<T>,
    ) {
        if !(source1.len() as i32 == source2.len() as i32) {
            panic!("{}", SR::arraysHadDifferentLengths());
        }
        for i in 0i32..=source1.len() as i32 - 1i32 {
            action(source1[i].clone(), source2[i].clone());
        }
    }
    pub fn iterateIndexed2<T: Clone + 'static>(
        action: Lrc<dyn Fn(i32, T, T) + 'static>,
        source1: Array<T>,
        source2: Array<T>,
    ) {
        if !(source1.len() as i32 == source2.len() as i32) {
            panic!("{}", SR::arraysHadDifferentLengths());
        }
        for i in 0i32..=source1.len() as i32 - 1i32 {
            action(i, source1[i].clone(), source2[i].clone());
        }
    }
    pub fn permute<T: Clone + 'static>(
        indexMap: Lrc<dyn Fn(i32) -> (i32) + 'static>,
        source: Array<T>,
    ) -> Array<T> {
        let len: i32 = source.len() as i32;
        let res: Array<T> = arrayCopy(source.clone());
        let checkFlags: Array<i32> = arrayCreate(&len, &0i32);
        Array_::iterateIndexed(
            Lrc::new({
                let checkFlags = checkFlags.clone();
                let indexMap = indexMap.clone();
                let len = len.clone();
                let res = res.clone();
                move |i: i32, x: T| {
                    let j: i32 = indexMap(i);
                    if if j < 0i32 { true } else { j >= len } {
                        panic!("{}", SR::notAPermutation());
                    }
                    res.get_mut()[j as usize] = x.clone();
                    checkFlags.get_mut()[j as usize] = 1i32
                }
            }),
            source,
        );
        if !Array_::forAll(Lrc::new(move |y: i32| 1i32 == y), checkFlags.clone()) {
            panic!("{}", SR::notAPermutation());
        }
        res.clone()
    }
    pub fn getSlice<T: Clone + 'static>(
        source: Array<T>,
        lower: Option<i32>,
        upper: Option<i32>,
    ) -> Array<T> {
        let patternInput: Lrc<(i32, i32)> = {
            let bound: i32 = 0i32;
            let lower_1: Option<i32> = lower;
            let upper_1: Option<i32> = upper;
            let length: i32 = source.len() as i32;
            Lrc::new((
                if lower_1.is_some() {
                    if getValue(lower_1.clone()) >= bound {
                        let n_1: i32 = getValue(lower_1);
                        n_1
                    } else {
                        bound
                    }
                } else {
                    bound
                },
                if upper_1.is_some() {
                    if getValue(upper_1.clone()) < bound + length {
                        let m_1: i32 = getValue(upper_1);
                        m_1
                    } else {
                        bound + length - 1i32
                    }
                } else {
                    bound + length - 1i32
                },
            ))
        };
        let start: i32 = patternInput.0.clone();
        Array_::getSubArray(source, start, patternInput.1.clone() - start + 1i32)
    }
    pub fn setSlice<T: Clone + 'static>(
        target: Array<T>,
        lower: Option<i32>,
        upper: Option<i32>,
        source: Array<T>,
    ) {
        let start: i32 = defaultArg(lower, 0i32);
        let count: i32 = defaultArg(upper, target.len() as i32 - 1i32) - start + 1i32;
        for i in 0i32..=count - 1i32 {
            target.get_mut()[(start + i) as usize] = source[i].clone();
        }
    }
    pub fn sortInPlaceWith<T: Clone + 'static>(
        comparer: Lrc<dyn Fn(T, T) -> (i32) + 'static>,
        source: Array<T>,
    ) {
        source.get_mut().sort_by(comparer_1(Lrc::new({
            let comparer = comparer.clone();
            move |delegateArg: T, delegateArg_1: T| {
                comparer(delegateArg.clone(), delegateArg_1.clone())
            }
        })));
    }
    pub fn sortInPlace<T: PartialOrd + Clone + 'static>(source: Array<T>) {
        Array_::sortInPlaceWith(
            Lrc::new(move |e: T, e_1: T| compare(e.clone(), e_1.clone())),
            source,
        );
    }
    pub fn sortInPlaceBy<T: Clone + 'static, U: PartialOrd + Clone + 'static>(
        projection: Lrc<dyn Fn(T) -> (U) + 'static>,
        source: Array<T>,
    ) {
        Array_::sortInPlaceWith(
            Lrc::new({
                let projection = projection.clone();
                move |x: T, y: T| compare(projection(x.clone()), projection(y.clone()))
            }),
            source,
        );
    }
    pub fn sort<T: PartialOrd + Clone + 'static>(source: Array<T>) -> Array<T> {
        let res: Array<T> = arrayCopy(source);
        Array_::sortInPlace(res.clone());
        res
    }
    pub fn sortBy<T: Clone + 'static, U: PartialOrd + Clone + 'static>(
        projection: Lrc<dyn Fn(T) -> (U) + 'static>,
        source: Array<T>,
    ) -> Array<T> {
        let res: Array<T> = arrayCopy(source);
        Array_::sortInPlaceBy(projection, res.clone());
        res
    }
    pub fn sortWith<T: Clone + 'static>(
        comparer: Lrc<dyn Fn(T, T) -> (i32) + 'static>,
        source: Array<T>,
    ) -> Array<T> {
        let res: Array<T> = arrayCopy(source);
        Array_::sortInPlaceWith(comparer, res.clone());
        res
    }
    pub fn sortDescending<T: PartialOrd + Clone + 'static>(source: Array<T>) -> Array<T> {
        Array_::sortWith(
            Lrc::new(move |x: T, y: T| compare(x.clone(), y.clone()) * -1i32),
            source,
        )
    }
    pub fn sortByDescending<T: Clone + 'static, U: PartialOrd + Clone + 'static>(
        projection: Lrc<dyn Fn(T) -> (U) + 'static>,
        source: Array<T>,
    ) -> Array<T> {
        Array_::sortWith(
            Lrc::new({
                let projection = projection.clone();
                move |x: T, y: T| compare(projection(x.clone()), projection(y.clone())) * -1i32
            }),
            source,
        )
    }
    pub fn allPairs<T1: Clone + 'static, T2: Clone + 'static>(
        xs: Array<T1>,
        ys: Array<T2>,
    ) -> Array<Lrc<(T1, T2)>> {
        let len1: i32 = xs.len() as i32;
        let len2: i32 = ys.len() as i32;
        let res: Array<Lrc<(T1, T2)>> = arrayWithCapacity::<Lrc<(T1, T2)>>(len1 * len2);
        for i in 0i32..=len1 - 1i32 {
            for j in 0i32..=len2 - 1i32 {
                res.get_mut().push(Lrc::new((xs[i].clone(), ys[j].clone())));
            }
        }
        (&res).clone()
    }
    pub fn unfold<State: Clone + 'static, T: Clone + 'static>(
        generator: Lrc<dyn Fn(State) -> (Option<Lrc<(T, State)>>) + 'static>,
        state: State,
    ) -> Array<T> {
        fn inner_loop<_a: Clone + 'static, T: Clone + 'static>(
            generator_1: Lrc<dyn Fn(_a) -> (Option<Lrc<(T, _a)>>) + 'static>,
            state_1: _a,
            res: Array<T>,
        ) {
            let generator_1 = MutCell::new(generator_1.clone());
            let state_1: MutCell<_a> = MutCell::new(state_1);
            let res: MutCell<Array<T>> = MutCell::new(res.clone());
            '_inner_loop: loop {
                break '_inner_loop ({
                    let matchValue: Option<Lrc<(T, _a)>> = generator_1(state_1.get());
                    match &matchValue {
                        Some(matchValue_0_0) => {
                            let x: T = (matchValue_0_0).0.clone();
                            let s: _a = (matchValue_0_0).1.clone();
                            res.get().get_mut().push(x);
                            {
                                let generator_1_temp = generator_1.get();
                                let state_1_temp: _a = s;
                                let res_temp: Array<T> = res.get();
                                generator_1.set(generator_1_temp);
                                state_1.set(state_1_temp);
                                res.set(res_temp);
                                continue '_inner_loop;
                            }
                        }
                        _ => (),
                    }
                });
            }
        }
        let res_1: Array<T> = arrayEmpty::<T>();
        inner_loop(generator, state, res_1.clone());
        (&res_1).clone()
    }
    pub fn unzip<T1: Clone + 'static, T2: Clone + 'static>(
        source: Array<Lrc<(T1, T2)>>,
    ) -> Lrc<(Array<T1>, Array<T2>)> {
        let len: i32 = source.len() as i32;
        let res1: Array<T1> = arrayWithCapacity::<T1>(len);
        let res2: Array<T2> = arrayWithCapacity::<T2>(len);
        Array_::iterateIndexed(
            Lrc::new({
                let res1 = res1.clone();
                let res2 = res2.clone();
                move |i: i32, tupledArg: Lrc<(T1, T2)>| {
                    res1.get_mut().push(tupledArg.0.clone());
                    res2.get_mut().push(tupledArg.1.clone())
                }
            }),
            source,
        );
        Lrc::new(((&res1).clone(), (&res2).clone()))
    }
    pub fn unzip3<T1: Clone + 'static, T2: Clone + 'static, T3: Clone + 'static>(
        source: Array<Lrc<(T1, T2, T3)>>,
    ) -> Lrc<(Array<T1>, Array<T2>, Array<T3>)> {
        let len: i32 = source.len() as i32;
        let res1: Array<T1> = arrayWithCapacity::<T1>(len);
        let res2: Array<T2> = arrayWithCapacity::<T2>(len);
        let res3: Array<T3> = arrayWithCapacity::<T3>(len);
        Array_::iterateIndexed(
            Lrc::new({
                let res1 = res1.clone();
                let res2 = res2.clone();
                let res3 = res3.clone();
                move |i: i32, tupledArg: Lrc<(T1, T2, T3)>| {
                    res1.get_mut().push(tupledArg.0.clone());
                    res2.get_mut().push(tupledArg.1.clone());
                    res3.get_mut().push(tupledArg.2.clone())
                }
            }),
            source,
        );
        Lrc::new(((&res1).clone(), (&res2).clone(), (&res3).clone()))
    }
    pub fn zip<T1: Clone + 'static, T2: Clone + 'static>(
        source1: Array<T1>,
        source2: Array<T2>,
    ) -> Array<Lrc<(T1, T2)>> {
        Array_::map2(
            Lrc::new(move |x: T1, y: T2| Lrc::new((x.clone(), y.clone()))),
            source1,
            source2,
        )
    }
    pub fn zip3<T1: Clone + 'static, T2: Clone + 'static, T3: Clone + 'static>(
        source1: Array<T1>,
        source2: Array<T2>,
        source3: Array<T3>,
    ) -> Array<Lrc<(T1, T2, T3)>> {
        Array_::map3(
            Lrc::new(move |x: T1, y: T2, z: T3| Lrc::new((x.clone(), y.clone(), z.clone()))),
            source1,
            source2,
            source3,
        )
    }
    pub fn chunkBySize<T: Clone + 'static>(chunkSize: i32, source: Array<T>) -> Array<Array<T>> {
        if chunkSize <= 0i32 {
            panic!(
                "{}",
                append_1(
                    append_1(SR::inputMustBePositive(), string("\\nParameter name: ")),
                    string("size")
                )
            );
        }
        {
            let len: i32 = source.len() as i32;
            let chunkCount: i32 = (len - 1i32) / chunkSize + 1i32;
            let res: Array<Array<T>> = arrayWithCapacity::<Array<T>>(chunkCount);
            for i in 0i32..=chunkCount - 1i32 {
                let start: i32 = i * chunkSize;
                let slice: Array<T> =
                    Array_::getSubArray(source.clone(), start, chunkSize.min(len - start));
                res.get_mut().push(slice.clone())
            }
            (&res).clone()
        }
    }
    pub fn splitAt<T: Clone + 'static>(index: i32, source: Array<T>) -> Lrc<(Array<T>, Array<T>)> {
        if if index < 0i32 {
            true
        } else {
            index > source.len() as i32
        } {
            panic!(
                "{}",
                append_1(
                    append_1(SR::indexOutOfBounds(), string("\\nParameter name: ")),
                    string("index")
                )
            );
        }
        Lrc::new((
            Array_::getSubArray(source.clone(), 0i32, index),
            Array_::getSubArray(source.clone(), index, source.len() as i32 - index),
        ))
    }
    pub fn sum<T: core::ops::Add<Output = T> + Default + Clone + 'static>(source: Array<T>) -> T {
        let acc: MutCell<T> = MutCell::new(getZero::<T>());
        for i in 0i32..=source.len() as i32 - 1i32 {
            acc.set(acc.get().clone() + source[i].clone());
        }
        acc.get()
    }
    pub fn sumBy<T: Clone + 'static, U: core::ops::Add<Output = U> + Default + Clone + 'static>(
        projection: Lrc<dyn Fn(T) -> (U) + 'static>,
        source: Array<T>,
    ) -> U {
        let acc: MutCell<U> = MutCell::new(getZero::<U>());
        for i in 0i32..=source.len() as i32 - 1i32 {
            acc.set(acc.get().clone() + projection(source[i].clone()));
        }
        acc.get()
    }
    pub fn maxBy<T: Clone + 'static, U: PartialOrd + Clone + 'static>(
        projection: Lrc<dyn Fn(T) -> (U) + 'static>,
        xs: Array<T>,
    ) -> T {
        Array_::reduce(
            Lrc::new({
                let projection = projection.clone();
                move |x: T, y: T| {
                    if projection(x.clone()) > projection(y.clone()) {
                        x.clone()
                    } else {
                        y.clone()
                    }
                }
            }),
            xs,
        )
    }
    pub fn max<T: PartialOrd + Clone + 'static>(xs: Array<T>) -> T {
        Array_::reduce(
            Lrc::new(move |x: T, y: T| {
                if x.clone() > y.clone() {
                    x.clone()
                } else {
                    y.clone()
                }
            }),
            xs,
        )
    }
    pub fn minBy<T: Clone + 'static, U: PartialOrd + Clone + 'static>(
        projection: Lrc<dyn Fn(T) -> (U) + 'static>,
        xs: Array<T>,
    ) -> T {
        Array_::reduce(
            Lrc::new({
                let projection = projection.clone();
                move |x: T, y: T| {
                    if projection(x.clone()) < projection(y.clone()) {
                        x.clone()
                    } else {
                        y.clone()
                    }
                }
            }),
            xs,
        )
    }
    pub fn min<T: PartialOrd + Clone + 'static>(xs: Array<T>) -> T {
        Array_::reduce(
            Lrc::new(move |x: T, y: T| {
                if x.clone() < y.clone() {
                    x.clone()
                } else {
                    y.clone()
                }
            }),
            xs,
        )
    }
    pub fn average<
        T: core::ops::Add<Output = T>
            + core::ops::Div<Output = T>
            + From<i32>
            + Default
            + Clone
            + 'static,
    >(
        source: Array<T>,
    ) -> T {
        if source.is_empty() {
            panic!(
                "{}",
                append_1(
                    append_1(SR::arrayWasEmpty(), string("\\nParameter name: ")),
                    string("array")
                )
            );
        }
        {
            let total: MutCell<T> = MutCell::new(getZero::<T>());
            for i in 0i32..=source.len() as i32 - 1i32 {
                total.set(total.get().clone() + source[i].clone());
            }
            total.get() / T::from(source.len() as i32).clone()
        }
    }
    pub fn averageBy<
        T: Clone + 'static,
        U: core::ops::Add<Output = U>
            + core::ops::Div<Output = U>
            + From<i32>
            + Default
            + Clone
            + 'static,
    >(
        projection: Lrc<dyn Fn(T) -> (U) + 'static>,
        source: Array<T>,
    ) -> U {
        if source.is_empty() {
            panic!(
                "{}",
                append_1(
                    append_1(SR::arrayWasEmpty(), string("\\nParameter name: ")),
                    string("array")
                )
            );
        }
        {
            let total: MutCell<U> = MutCell::new(getZero::<U>());
            for i in 0i32..=source.len() as i32 - 1i32 {
                total.set(total.get().clone() + projection(source[i].clone()));
            }
            total.get() / U::from(source.len() as i32).clone()
        }
    }
    pub fn ofOption<T: Clone + 'static>(opt: Option<T>) -> Array<T> {
        match &opt {
            None => arrayCreate(&0i32, &defaultOf::<T>()),
            Some(opt_0_0) => arrayCreate(&1i32, &opt_0_0),
        }
    }
    pub fn r#where<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        source: Array<T>,
    ) -> Array<T> {
        Array_::filter(predicate, source)
    }
    pub fn windowed<T: Clone + 'static>(windowSize: i32, source: Array<T>) -> Array<Array<T>> {
        if windowSize <= 0i32 {
            panic!(
                "{}",
                append_1(
                    append_1(SR::inputMustBePositive(), string("\\nParameter name: ")),
                    string("size")
                )
            );
        }
        {
            let len: i32 = 0i32.max(source.len() as i32 - windowSize + 1i32);
            let res: Array<Array<T>> = arrayWithCapacity::<Array<T>>(len);
            for i in 0i32..=len - 1i32 {
                let slice: Array<T> = Array_::getSubArray(source.clone(), i, windowSize);
                res.get_mut().push(slice.clone())
            }
            (&res).clone()
        }
    }
    pub fn splitInto<T: Clone + 'static>(chunks: i32, source: Array<T>) -> Array<Array<T>> {
        if chunks <= 0i32 {
            panic!(
                "{}",
                append_1(
                    append_1(SR::inputMustBePositive(), string("\\nParameter name: ")),
                    string("chunks")
                )
            );
        }
        if source.is_empty() {
            (&arrayEmpty::<Array<T>>()).clone()
        } else {
            let res: Array<Array<T>> = arrayWithCapacity::<Array<T>>(chunks);
            let chunks_1: i32 = chunks.min(source.len() as i32);
            let minChunkSize: i32 = source.len() as i32 / chunks_1;
            let chunksWithExtraItem: i32 = source.len() as i32 % chunks_1;
            for i in 0i32..=chunks_1 - 1i32 {
                let chunkSize: i32 = if i < chunksWithExtraItem {
                    minChunkSize + 1i32
                } else {
                    minChunkSize
                };
                let slice: Array<T> = Array_::getSubArray(
                    source.clone(),
                    i * minChunkSize + chunksWithExtraItem.min(i),
                    chunkSize,
                );
                res.get_mut().push(slice.clone())
            }
            (&res).clone()
        }
    }
    pub fn transpose<T: Clone + 'static>(arrays: Array<Array<T>>) -> Array<Array<T>> {
        if arrays.is_empty() {
            (&arrayEmpty::<Array<T>>()).clone()
        } else {
            let len: i32 = arrays.len() as i32;
            let firstArray: Array<T> = arrays[0i32].clone();
            let innerLen: i32 = firstArray.len() as i32;
            if !Array_::forAll(
                Lrc::new({
                    let innerLen = innerLen.clone();
                    move |a_2: Array<T>| a_2.len() as i32 == innerLen
                }),
                arrays.clone(),
            ) {
                panic!("{}", SR::arraysHadDifferentLengths());
            }
            {
                let res: Array<Array<T>> = arrayWithCapacity::<Array<T>>(innerLen);
                for i in 0i32..=innerLen - 1i32 {
                    let res2: Array<T> = arrayWithCapacity::<T>(len);
                    for j in 0i32..=len - 1i32 {
                        res2.get_mut().push((arrays[j].clone())[i].clone());
                    }
                    res.get_mut().push((&res2).clone())
                }
                (&res).clone()
            }
        }
    }
    pub fn distinct<T: Eq + core::hash::Hash + Clone + 'static>(xs: Array<T>) -> Array<T> {
        let hashSet: HashSet<T> = empty::<T>();
        Array_::filter(
            Lrc::new({
                let hashSet = hashSet.clone();
                move |x: T| hashSet.get_mut().insert(x.clone())
            }),
            xs,
        )
    }
    pub fn distinctBy<T: Clone + 'static, Key: Eq + core::hash::Hash + Clone + 'static>(
        projection: Lrc<dyn Fn(T) -> (Key) + 'static>,
        xs: Array<T>,
    ) -> Array<T> {
        let hashSet: HashSet<Key> = empty::<Key>();
        Array_::filter(
            Lrc::new({
                let hashSet = hashSet.clone();
                let projection = projection.clone();
                move |x: T| hashSet.get_mut().insert(projection(x.clone()))
            }),
            xs,
        )
    }
    pub fn except<T: Eq + core::hash::Hash + Clone + 'static>(
        itemsToExclude: Lrc<dyn IEnumerable_1<T>>,
        xs: Array<T>,
    ) -> Array<T> {
        let hashSet: HashSet<T> = fromArray(toArray(itemsToExclude));
        Array_::filter(
            Lrc::new({
                let hashSet = hashSet.clone();
                move |x: T| hashSet.get_mut().insert(x.clone())
            }),
            xs,
        )
    }
    pub fn countBy<T: Clone + 'static, Key: Eq + core::hash::Hash + Clone + 'static>(
        projection: Lrc<dyn Fn(T) -> (Key) + 'static>,
        xs: Array<T>,
    ) -> Array<Lrc<(Key, i32)>> {
        let dict: HashMap<Key, i32> = empty_1::<Key, i32>();
        let keys: Array<Key> = arrayEmpty::<Key>();
        for idx in 0i32..=xs.len() as i32 - 1i32 {
            let key: Key = projection(xs[idx].clone());
            let matchValue: Lrc<(bool, i32)> = {
                let outArg: MutCell<i32> = MutCell::new(0i32);
                Lrc::new((
                    tryGetValue(dict.clone(), key.clone(), &outArg),
                    outArg.get(),
                ))
            };
            if matchValue.0.clone() {
                set(dict.clone(), key.clone(), matchValue.1.clone() + 1i32)
            } else {
                set(dict.clone(), key.clone(), 1i32);
                keys.get_mut().push(key.clone())
            }
        }
        Array_::map(
            Lrc::new({
                let dict = dict.clone();
                move |key_1: Key| Lrc::new((key_1.clone(), get(dict.clone(), key_1.clone())))
            }),
            (&keys).clone(),
        )
    }
    pub fn groupBy<T: Clone + 'static, Key: Eq + core::hash::Hash + Clone + 'static>(
        projection: Lrc<dyn Fn(T) -> (Key) + 'static>,
        xs: Array<T>,
    ) -> Array<Lrc<(Key, Array<T>)>> {
        let dict: HashMap<Key, Array<T>> = empty_1::<Key, Array<T>>();
        let keys: Array<Key> = arrayEmpty::<Key>();
        for idx in 0i32..=xs.len() as i32 - 1i32 {
            let x: T = xs[idx].clone();
            let key: Key = projection(x.clone());
            let matchValue: Lrc<(bool, Array<T>)> = {
                let outArg: MutCell<Array<T>> = MutCell::new(arrayEmpty::<T>());
                Lrc::new((
                    tryGetValue(dict.clone(), key.clone(), &outArg),
                    outArg.get().clone(),
                ))
            };
            if matchValue.0.clone() {
                matchValue.1.clone().get_mut().push(x.clone())
            } else {
                add(dict.clone(), key.clone(), array(&[x]));
                keys.get_mut().push(key.clone())
            }
        }
        Array_::map(
            Lrc::new({
                let dict = dict.clone();
                move |key_1: Key| {
                    Lrc::new((key_1.clone(), (&get(dict.clone(), key_1.clone())).clone()))
                }
            }),
            (&keys).clone(),
        )
    }
    pub fn insertAt<T: Clone + 'static>(index: i32, y: T, xs: Array<T>) -> Array<T> {
        let len: i32 = xs.len() as i32;
        if if index < 0i32 { true } else { index > len } {
            panic!(
                "{}",
                append_1(
                    append_1(SR::indexOutOfBounds(), string("\\nParameter name: ")),
                    string("index")
                )
            );
        }
        {
            let res: Array<T> = arrayWithCapacity::<T>(len + 1i32);
            for i in 0i32..=index - 1i32 {
                res.get_mut().push(xs[i].clone());
            }
            res.get_mut().push(y);
            for i_1 in index..=len - 1i32 {
                res.get_mut().push(xs[i_1].clone());
            }
            (&res).clone()
        }
    }
    pub fn insertManyAt<T: Clone + 'static>(
        index: i32,
        ys: Lrc<dyn IEnumerable_1<T>>,
        xs: Array<T>,
    ) -> Array<T> {
        let len: i32 = xs.len() as i32;
        if if index < 0i32 { true } else { index > len } {
            panic!(
                "{}",
                append_1(
                    append_1(SR::indexOutOfBounds(), string("\\nParameter name: ")),
                    string("index")
                )
            );
        }
        {
            let ys_1: Array<T> = toArray(ys);
            let len2: i32 = ys_1.len() as i32;
            let res: Array<T> = arrayWithCapacity::<T>(len + len2);
            for i in 0i32..=index - 1i32 {
                res.get_mut().push(xs[i].clone());
            }
            for i_1 in 0i32..=len2 - 1i32 {
                res.get_mut().push(ys_1[i_1].clone());
            }
            for i_2 in index..=len - 1i32 {
                res.get_mut().push(xs[i_2].clone());
            }
            (&res).clone()
        }
    }
    pub fn removeAt<T: Clone + 'static>(index: i32, xs: Array<T>) -> Array<T> {
        if if index < 0i32 {
            true
        } else {
            index >= xs.len() as i32
        } {
            panic!(
                "{}",
                append_1(
                    append_1(SR::indexOutOfBounds(), string("\\nParameter name: ")),
                    string("index")
                )
            );
        }
        {
            let i: Lrc<MutCell<i32>> = Lrc::new(MutCell::new(-1i32));
            Array_::filter(
                Lrc::new({
                    let i = i.clone();
                    let index = index.clone();
                    move |_arg: T| {
                        i.set(i.get() + 1i32);
                        !(i.get() == index)
                    }
                }),
                xs,
            )
        }
    }
    pub fn removeManyAt<T: Clone + 'static>(index: i32, count: i32, xs: Array<T>) -> Array<T> {
        let i: Lrc<MutCell<i32>> = Lrc::new(MutCell::new(-1i32));
        let status: Lrc<MutCell<i32>> = Lrc::new(MutCell::new(-1i32));
        let res: Array<T> = Array_::filter(
            Lrc::new({
                let count = count.clone();
                let i = i.clone();
                let index = index.clone();
                let status = status.clone();
                move |_arg: T| {
                    i.set(i.get() + 1i32);
                    if i.get() == index {
                        status.set(0i32);
                        false
                    } else {
                        if i.get() > index {
                            if i.get() < index + count {
                                false
                            } else {
                                status.set(1i32);
                                true
                            }
                        } else {
                            true
                        }
                    }
                }
            }),
            xs,
        );
        let status_1: i32 = if if status.get() == 0i32 {
            i.get() + 1i32 == index + count
        } else {
            false
        } {
            1i32
        } else {
            status.get()
        };
        if status_1 < 1i32 {
            panic!(
                "{}",
                append_1(
                    append_1(SR::indexOutOfBounds(), string("\\nParameter name: ")),
                    (if status_1 < 0i32 {
                        string("index")
                    } else {
                        string("count")
                    })
                )
            );
        }
        res
    }
    pub fn updateAt<T: Clone + 'static>(index: i32, y: T, xs: Array<T>) -> Array<T> {
        let len: i32 = xs.len() as i32;
        if if index < 0i32 { true } else { index >= len } {
            panic!(
                "{}",
                append_1(
                    append_1(SR::indexOutOfBounds(), string("\\nParameter name: ")),
                    string("index")
                )
            );
        }
        {
            let res: Array<T> = arrayWithCapacity::<T>(len);
            for i in 0i32..=len - 1i32 {
                res.get_mut()
                    .push(if i == index { y.clone() } else { xs[i].clone() });
            }
            (&res).clone()
        }
    }
}
