pub mod Interfaces_ {
    use super::*;
    pub mod System {
        use super::*;
        pub trait IDisposable {
            fn Dispose(&self);
        }
        pub mod Collections {
            use super::*;
            pub mod Generic {
                use super::*;
                use crate::module_2031347a::Native_::Array;
                use crate::module_2031347a::Native_::Lrc;
                use crate::module_2031347a::Native_::MutCell;
                pub trait IEnumerator_1<T: Clone + 'static> {
                    fn MoveNext(&self) -> bool;
                    fn Reset(&self);
                    fn Current(&self) -> T;
                    fn Dispose(&self);
                }
                pub trait IEnumerable_1<T: Clone + 'static> {
                    fn GetEnumerator(
                        &self,
                    ) -> Lrc<dyn Interfaces_::System::Collections::Generic::IEnumerator_1<T>>;
                }
                pub trait ICollection_1<T: Clone + 'static> {
                    fn Add(&self, arg0: T);
                    fn Clear(&self);
                    fn Contains(&self, arg0: T) -> bool;
                    fn CopyTo(&self, arg0: Array<T>, arg1: i32);
                    fn Remove(&self, arg0: T) -> bool;
                    fn Count(&self) -> i32;
                    fn IsReadOnly(&self) -> bool;
                }
                pub trait IDictionary_2<K: Clone + 'static, V: Clone + 'static> {
                    fn Add(&self, arg0: K, arg1: V);
                    fn ContainsKey(&self, arg0: K) -> bool;
                    fn Remove(&self, arg0: K) -> bool;
                    fn TryGetValue(&self, arg0: K, arg1: &MutCell<V>) -> bool;
                    fn Item(&self, arg0: K) -> V;
                    fn Keys(
                        &self,
                    ) -> Lrc<dyn Interfaces_::System::Collections::Generic::ICollection_1<K>>;
                    fn Values(
                        &self,
                    ) -> Lrc<dyn Interfaces_::System::Collections::Generic::ICollection_1<V>>;
                }
            }
        }
    }
}
