pub mod List_ {
    use super::*;
    use crate::module_2031347a::Native_::array as array_2;
    use crate::module_2031347a::Native_::arrayEmpty;
    use crate::module_2031347a::Native_::arrayWithCapacity;
    use crate::module_2031347a::Native_::getZero;
    use crate::module_2031347a::Native_::Any;
    use crate::module_2031347a::Native_::Array;
    use crate::module_2031347a::Native_::Lrc;
    use crate::module_2031347a::Native_::MutCell;
    use crate::module_25e675f8::Option_::getValue;
    use crate::module_75c81ae2::Array_::chunkBySize as chunkBySize_1;
    use crate::module_75c81ae2::Array_::map as map_1;
    use crate::module_75c81ae2::Array_::pairwise as pairwise_1;
    use crate::module_75c81ae2::Array_::permute as permute_1;
    use crate::module_75c81ae2::Array_::scan as scan_1;
    use crate::module_75c81ae2::Array_::scanBack as scanBack_1;
    use crate::module_75c81ae2::Array_::sortInPlaceWith;
    use crate::module_75c81ae2::Array_::splitInto as splitInto_1;
    use crate::module_75c81ae2::Array_::tryFindBack as tryFindBack_1;
    use crate::module_75c81ae2::Array_::tryFindIndexBack as tryFindIndexBack_1;
    use crate::module_75c81ae2::Array_::windowed as windowed_1;
    use crate::module_912d02ed::Interfaces_::System::Collections::Generic::IEnumerable_1;
    use crate::module_912d02ed::Interfaces_::System::Collections::Generic::IEnumerator_1;
    use crate::module_912d02ed::Interfaces_::System::IDisposable;
    use crate::module_982cddd5::HashMap_::add;
    use crate::module_982cddd5::HashMap_::empty as empty_2;
    use crate::module_982cddd5::HashMap_::get;
    use crate::module_982cddd5::HashMap_::set;
    use crate::module_982cddd5::HashMap_::tryGetValue;
    use crate::module_982cddd5::HashMap_::HashMap;
    use crate::module_9d52c5fc::Seq_::toArray as toArray_1;
    use crate::module_a61cad0b::HashSet_::empty as empty_1;
    use crate::module_a61cad0b::HashSet_::fromArray;
    use crate::module_a61cad0b::HashSet_::HashSet;
    use crate::module_b1128850::Global_::SR;
    use crate::module_c5a2a64e::String_::append as append_1;
    use crate::module_c5a2a64e::String_::string;
    use crate::module_d98fc69f::Util_::compare;
    use crate::module_d98fc69f::Util_::ignore;
    #[derive(Clone, Debug, Default, PartialEq, PartialOrd, Hash, Eq, Ord)]
    pub struct Node_1<T: Clone + 'static> {
        pub head: T,
        pub tail: MutCell<List_::List<T>>,
    }
    #[derive(Clone, Debug, Default, PartialEq, PartialOrd, Hash, Eq, Ord)]
    pub struct List<T: Clone + 'static> {
        pub root: Option<Lrc<List_::Node_1<T>>>,
    }
    fn mkList<_a: Clone + 'static>(root: Option<Lrc<List_::Node_1<_a>>>) -> List_::List<_a> {
        List_::List::<_a> { root: root }
    }
    fn appendConsNoTail<T: Clone + 'static>(
        x: T,
        node: Option<Lrc<List_::Node_1<T>>>,
    ) -> Option<Lrc<List_::Node_1<T>>> {
        let tail_1: Option<Lrc<List_::Node_1<T>>> = Some(Lrc::new(List_::Node_1::<T> {
            head: x,
            tail: MutCell::new(List_::mkList(None::<Lrc<List_::Node_1<T>>>)),
        }));
        {
            let node_1: Option<Lrc<List_::Node_1<T>>> = node;
            match &node_1 {
                None => (),
                Some(node_1_0_0) => {
                    let node_1_1: Lrc<List_::Node_1<T>> = node_1_0_0.clone();
                    node_1_1.tail.set(List_::mkList(tail_1.clone()))
                }
            }
        }
        tail_1.clone()
    }
    pub fn empty<T: Clone + 'static>() -> List_::List<T> {
        List_::mkList(None::<Lrc<List_::Node_1<T>>>)
    }
    pub fn cons<T: Clone + 'static>(x: T, xs: List_::List<T>) -> List_::List<T> {
        List_::mkList(Some(Lrc::new(List_::Node_1::<T> {
            head: x,
            tail: MutCell::new(xs),
        })))
    }
    pub fn singleton<T: Clone + 'static>(x: T) -> List_::List<T> {
        List_::cons(x, List_::empty())
    }
    pub fn isEmpty<T: Clone + 'static>(xs: List_::List<T>) -> bool {
        xs.root.is_none()
    }
    pub fn head<T: Clone + 'static>(xs: List_::List<T>) -> T {
        let matchValue: Option<Lrc<List_::Node_1<T>>> = xs.root.clone();
        match &matchValue {
            None => panic!(
                "{}",
                append_1(
                    append_1(SR::inputListWasEmpty(), string("\\nParameter name: ")),
                    string("list")
                )
            ),
            Some(matchValue_0_0) => (matchValue_0_0).head.clone(),
        }
    }
    pub fn tryHead<T: Clone + 'static>(xs: List_::List<T>) -> Option<T> {
        let matchValue: Option<Lrc<List_::Node_1<T>>> = xs.root.clone();
        match &matchValue {
            None => None::<T>,
            Some(matchValue_0_0) => Some((matchValue_0_0).head.clone()),
        }
    }
    pub fn tail<T: Clone + 'static>(xs: List_::List<T>) -> List_::List<T> {
        let matchValue: Option<Lrc<List_::Node_1<T>>> = xs.root.clone();
        match &matchValue {
            None => panic!(
                "{}",
                append_1(
                    append_1(SR::inputListWasEmpty(), string("\\nParameter name: ")),
                    string("list")
                )
            ),
            Some(matchValue_0_0) => {
                let node: Lrc<List_::Node_1<T>> = matchValue_0_0.clone();
                node.tail.get().clone()
            }
        }
    }
    pub fn length<T: Clone + 'static>(xs: List_::List<T>) -> i32 {
        fn inner_loop<_a: Clone + 'static>(i: i32, xs_1: List_::List<_a>) -> i32 {
            let i: MutCell<i32> = MutCell::new(i);
            let xs_1: MutCell<List_::List<_a>> = MutCell::new(xs_1);
            '_inner_loop: loop {
                break '_inner_loop ({
                    let matchValue: Option<Lrc<List_::Node_1<_a>>> = xs_1.root.clone();
                    match &matchValue {
                        Some(matchValue_0_0) => {
                            let node: Lrc<List_::Node_1<_a>> = matchValue_0_0.clone();
                            {
                                let i_temp: i32 = i.get() + 1i32;
                                let xs_1_temp: List_::List<_a> = node.tail.get().clone();
                                i.set(i_temp);
                                xs_1.set(xs_1_temp);
                                continue '_inner_loop;
                            }
                        }
                        _ => i.get(),
                    }
                });
            }
        }
        inner_loop(0i32, xs)
    }
    pub fn tryLast<T: Clone + 'static>(xs: List_::List<T>) -> Option<T> {
        let xs: MutCell<List_::List<T>> = MutCell::new(xs);
        '_tryLast: loop {
            break '_tryLast ({
                let matchValue: Option<Lrc<List_::Node_1<T>>> = xs.root.clone();
                match &matchValue {
                    Some(matchValue_0_0) => {
                        let node: Lrc<List_::Node_1<T>> = matchValue_0_0.clone();
                        if List_::isEmpty(node.tail.get().clone()) {
                            Some(node.head.clone())
                        } else {
                            let xs_temp: List_::List<T> = node.tail.get().clone();
                            xs.set(xs_temp);
                            continue '_tryLast;
                        }
                    }
                    _ => None::<T>,
                }
            });
        }
    }
    pub fn last<T: Clone + 'static>(xs: List_::List<T>) -> T {
        let matchValue: Option<T> = List_::tryLast(xs);
        match &matchValue {
            None => panic!("{}", SR::inputListWasEmpty()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn ofOption<T: Clone + 'static>(opt: Option<T>) -> List_::List<T> {
        match &opt {
            None => List_::empty(),
            Some(opt_0_0) => List_::singleton(opt_0_0.clone()),
        }
    }
    pub fn ofSeq<T: Clone + 'static>(xs: Lrc<dyn IEnumerable_1<T>>) -> List_::List<T> {
        let root: MutCell<Option<Lrc<List_::Node_1<T>>>> =
            MutCell::new(None::<Lrc<List_::Node_1<T>>>);
        let node: MutCell<Option<Lrc<List_::Node_1<T>>>> = MutCell::new(root.get().clone());
        {
            let enumerator: Lrc<dyn IEnumerator_1<T>> = xs.GetEnumerator();
            {
                let try_result = while enumerator.MoveNext() {
                    let x: T = enumerator.Current();
                    node.set(List_::appendConsNoTail(x.clone(), node.get().clone()));
                    if root.get().is_none() {
                        root.set(node.get().clone());
                    }
                };
                if ((&enumerator) as &dyn Any).is::<Lrc<dyn IDisposable>>() {
                    (&enumerator).Dispose();
                }
                try_result
            }
        }
        List_::mkList(root.get())
    }
    pub fn toArray<T: Clone + 'static>(xs: List_::List<T>) -> Array<T> {
        let res: Array<T> = arrayWithCapacity::<T>(List_::length(xs.clone()));
        let xs_1: MutCell<List_::List<T>> = MutCell::new(xs);
        while !List_::isEmpty(xs_1.get().clone()) {
            res.get_mut().push(List_::head(xs_1.get().clone()));
            xs_1.set(List_::tail(xs_1.get().clone()))
        }
        (&res).clone()
    }
    pub fn fold<State: Clone + 'static, T: Clone + 'static>(
        folder: Lrc<dyn Fn(State, T) -> (State) + 'static>,
        state: State,
        xs: List_::List<T>,
    ) -> State {
        let acc: MutCell<State> = MutCell::new(state);
        let xs_1: MutCell<List_::List<T>> = MutCell::new(xs);
        while !List_::isEmpty(xs_1.get().clone()) {
            acc.set(folder(acc.get().clone(), List_::head(xs_1.get().clone())));
            xs_1.set(List_::tail(xs_1.get().clone()))
        }
        acc.get()
    }
    pub fn reverse<T: Clone + 'static>(xs: List_::List<T>) -> List_::List<T> {
        List_::fold(
            Lrc::new(move |acc: List_::List<T>, x: T| List_::cons(x.clone(), acc.clone())),
            List_::empty(),
            xs,
        )
    }
    pub fn foldBack<T: Clone + 'static, State: Clone + 'static>(
        folder: Lrc<dyn Fn(T, State) -> (State) + 'static>,
        xs: List_::List<T>,
        state: State,
    ) -> State {
        List_::fold(
            Lrc::new({
                let folder = folder.clone();
                move |acc: State, x: T| folder(x.clone(), acc.clone())
            }),
            state,
            List_::reverse(xs),
        )
    }
    pub fn fold2<State: Clone + 'static, T1: Clone + 'static, T2: Clone + 'static>(
        folder: Lrc<dyn Fn(State, T1, T2) -> (State) + 'static>,
        state: State,
        xs: List_::List<T1>,
        ys: List_::List<T2>,
    ) -> State {
        let acc: MutCell<State> = MutCell::new(state);
        let xs_1: MutCell<List_::List<T1>> = MutCell::new(xs);
        let ys_1: MutCell<List_::List<T2>> = MutCell::new(ys);
        while if !List_::isEmpty(xs_1.get().clone()) {
            !List_::isEmpty(ys_1.get().clone())
        } else {
            false
        } {
            acc.set(folder(
                acc.get().clone(),
                List_::head(xs_1.get().clone()),
                List_::head(ys_1.get().clone()),
            ));
            xs_1.set(List_::tail(xs_1.get().clone()));
            ys_1.set(List_::tail(ys_1.get().clone()))
        }
        acc.get()
    }
    pub fn foldBack2<T1: Clone + 'static, T2: Clone + 'static, State: Clone + 'static>(
        folder: Lrc<dyn Fn(T1, T2, State) -> (State) + 'static>,
        xs: List_::List<T1>,
        ys: List_::List<T2>,
        state: State,
    ) -> State {
        List_::fold2(
            Lrc::new({
                let folder = folder.clone();
                move |acc: State, x: T1, y: T2| folder(x.clone(), y.clone(), acc.clone())
            }),
            state,
            List_::reverse(xs),
            List_::reverse(ys),
        )
    }
    pub fn forAll<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        xs: List_::List<T>,
    ) -> bool {
        let predicate = MutCell::new(predicate.clone());
        let xs: MutCell<List_::List<T>> = MutCell::new(xs.clone());
        '_forAll: loop {
            break '_forAll (if List_::isEmpty(xs.get()) {
                true
            } else {
                if predicate(List_::head(xs.get())) {
                    let predicate_temp = predicate.get();
                    let xs_temp: List_::List<T> = List_::tail(xs.get());
                    predicate.set(predicate_temp);
                    xs.set(xs_temp);
                    continue '_forAll;
                } else {
                    false
                }
            });
        }
    }
    pub fn forAll2<T1: Clone + 'static, T2: Clone + 'static>(
        predicate: Lrc<dyn Fn(T1, T2) -> (bool) + 'static>,
        xs: List_::List<T1>,
        ys: List_::List<T2>,
    ) -> bool {
        let predicate = MutCell::new(predicate.clone());
        let xs: MutCell<List_::List<T1>> = MutCell::new(xs.clone());
        let ys: MutCell<List_::List<T2>> = MutCell::new(ys.clone());
        '_forAll2: loop {
            break '_forAll2 ({
                let matchValue: bool = List_::isEmpty(xs.get());
                let matchValue_1: bool = List_::isEmpty(ys.get());
                if matchValue {
                    if matchValue_1 {
                        true
                    } else {
                        panic!(
                            "{}",
                            append_1(
                                append_1(
                                    SR::listsHadDifferentLengths(),
                                    string("\\nParameter name: ")
                                ),
                                string("list2")
                            )
                        )
                    }
                } else {
                    if matchValue_1 {
                        panic!(
                            "{}",
                            append_1(
                                append_1(
                                    SR::listsHadDifferentLengths(),
                                    string("\\nParameter name: ")
                                ),
                                string("list2")
                            )
                        )
                    } else {
                        if predicate(List_::head(xs.get()), List_::head(ys.get())) {
                            let predicate_temp = predicate.get();
                            let xs_temp: List_::List<T1> = List_::tail(xs.get());
                            let ys_temp: List_::List<T2> = List_::tail(ys.get());
                            predicate.set(predicate_temp);
                            xs.set(xs_temp);
                            ys.set(ys_temp);
                            continue '_forAll2;
                        } else {
                            false
                        }
                    }
                }
            });
        }
    }
    pub fn unfold<State: Clone + 'static, T: Clone + 'static>(
        gen: Lrc<dyn Fn(State) -> (Option<Lrc<(T, State)>>) + 'static>,
        state: State,
    ) -> List_::List<T> {
        let root: MutCell<Option<Lrc<List_::Node_1<T>>>> =
            MutCell::new(None::<Lrc<List_::Node_1<T>>>);
        let node: MutCell<Option<Lrc<List_::Node_1<T>>>> = MutCell::new(root.get().clone());
        let acc: MutCell<Option<Lrc<(T, State)>>> = MutCell::new(gen(state));
        while acc.get().is_some() {
            let patternInput: Lrc<(T, State)> = getValue(acc.get().clone());
            node.set(List_::appendConsNoTail(
                patternInput.0.clone(),
                node.get().clone(),
            ));
            if root.get().is_none() {
                root.set(node.get().clone());
            }
            acc.set(gen(patternInput.1.clone()))
        }
        List_::mkList(root.get())
    }
    pub fn iterate<T: Clone + 'static>(action: Lrc<dyn Fn(T) + 'static>, xs: List_::List<T>) {
        List_::fold(
            Lrc::new({
                let action = action.clone();
                move |unitVar: (), x: T| action(x.clone())
            }),
            (),
            xs,
        );
    }
    pub fn iterate2<T1: Clone + 'static, T2: Clone + 'static>(
        action: Lrc<dyn Fn(T1, T2) + 'static>,
        xs: List_::List<T1>,
        ys: List_::List<T2>,
    ) {
        List_::fold2(
            Lrc::new({
                let action = action.clone();
                move |unitVar: (), x: T1, y: T2| action(x.clone(), y.clone())
            }),
            (),
            xs,
            ys,
        );
    }
    pub fn iterateIndexed<T: Clone + 'static>(
        action: Lrc<dyn Fn(i32, T) + 'static>,
        xs: List_::List<T>,
    ) {
        ignore(List_::fold(
            Lrc::new({
                let action = action.clone();
                move |i: i32, x: T| {
                    action(i, x.clone());
                    i + 1i32
                }
            }),
            0i32,
            xs,
        ));
    }
    pub fn iterateIndexed2<T1: Clone + 'static, T2: Clone + 'static>(
        action: Lrc<dyn Fn(i32, T1, T2) + 'static>,
        xs: List_::List<T1>,
        ys: List_::List<T2>,
    ) {
        ignore(List_::fold2(
            Lrc::new({
                let action = action.clone();
                move |i: i32, x: T1, y: T2| {
                    action(i, x.clone(), y.clone());
                    i + 1i32
                }
            }),
            0i32,
            xs,
            ys,
        ));
    }
    pub fn ofArrayWithTail<T: Clone + 'static>(
        xs: Array<T>,
        tail_1: List_::List<T>,
    ) -> List_::List<T> {
        let res: MutCell<List_::List<T>> = MutCell::new(tail_1);
        let len: i32 = xs.len() as i32;
        for i in (0i32..=len - 1i32).rev() {
            res.set(List_::cons(xs[i].clone(), res.get().clone()));
        }
        res.get()
    }
    pub fn ofArray<T: Clone + 'static>(xs: Array<T>) -> List_::List<T> {
        List_::ofArrayWithTail(xs, List_::empty())
    }
    pub fn append<T: Clone + 'static>(xs: List_::List<T>, ys: List_::List<T>) -> List_::List<T> {
        List_::fold(
            Lrc::new(move |acc: List_::List<T>, x: T| List_::cons(x.clone(), acc.clone())),
            ys,
            List_::reverse(xs),
        )
    }
    pub fn choose<T: Clone + 'static, U: Clone + 'static>(
        chooser: Lrc<dyn Fn(T) -> (Option<U>) + 'static>,
        xs: List_::List<T>,
    ) -> List_::List<U> {
        let root: MutCell<Option<Lrc<List_::Node_1<U>>>> =
            MutCell::new(None::<Lrc<List_::Node_1<U>>>);
        let node: MutCell<Option<Lrc<List_::Node_1<U>>>> = MutCell::new(root.get().clone());
        let xs_1: MutCell<List_::List<T>> = MutCell::new(xs);
        while !List_::isEmpty(xs_1.get().clone()) {
            {
                let matchValue: Option<U> = chooser(List_::head(xs_1.get().clone()));
                match &matchValue {
                    None => (),
                    Some(matchValue_0_0) => {
                        let x: U = matchValue_0_0.clone();
                        node.set(List_::appendConsNoTail(x.clone(), node.get().clone()));
                        if root.get().is_none() {
                            root.set(node.get().clone());
                        }
                    }
                }
            }
            xs_1.set(List_::tail(xs_1.get().clone()))
        }
        List_::mkList(root.get())
    }
    pub fn concat<T: Clone + 'static>(sources: List_::List<List_::List<T>>) -> List_::List<T> {
        let root: MutCell<Option<Lrc<List_::Node_1<T>>>> =
            MutCell::new(None::<Lrc<List_::Node_1<T>>>);
        let node: MutCell<Option<Lrc<List_::Node_1<T>>>> = MutCell::new(root.get().clone());
        let xs: MutCell<List_::List<List_::List<T>>> = MutCell::new(sources);
        let ys: MutCell<List_::List<T>> = MutCell::new(List_::empty());
        while !List_::isEmpty(xs.get().clone()) {
            ys.set(List_::head(xs.get().clone()));
            while !List_::isEmpty(ys.get().clone()) {
                node.set({
                    let node_1: Option<Lrc<List_::Node_1<T>>> = node.get().clone();
                    List_::appendConsNoTail(List_::head(ys.get().clone()), node_1)
                });
                if root.get().is_none() {
                    root.set(node.get().clone());
                }
                ys.set(List_::tail(ys.get().clone()))
            }
            xs.set(List_::tail(xs.get().clone()))
        }
        List_::mkList(root.get())
    }
    pub fn compareWith<T: Clone + 'static>(
        comparer: Lrc<dyn Fn(T, T) -> (i32) + 'static>,
        xs: List_::List<T>,
        ys: List_::List<T>,
    ) -> i32 {
        let comparer = MutCell::new(comparer.clone());
        let xs: MutCell<List_::List<T>> = MutCell::new(xs.clone());
        let ys: MutCell<List_::List<T>> = MutCell::new(ys.clone());
        '_compareWith: loop {
            break '_compareWith ({
                let matchValue: bool = List_::isEmpty(xs.get());
                let matchValue_1: bool = List_::isEmpty(ys.get());
                if matchValue {
                    if matchValue_1 {
                        0i32
                    } else {
                        -1i32
                    }
                } else {
                    if matchValue_1 {
                        1i32
                    } else {
                        let c: i32 = comparer(List_::head(xs.get()), List_::head(ys.get()));
                        if c == 0i32 {
                            let comparer_temp = comparer.get();
                            let xs_temp: List_::List<T> = List_::tail(xs.get());
                            let ys_temp: List_::List<T> = List_::tail(ys.get());
                            comparer.set(comparer_temp);
                            xs.set(xs_temp);
                            ys.set(ys_temp);
                            continue '_compareWith;
                        } else {
                            c
                        }
                    }
                }
            });
        }
    }
    pub fn compareTo<T: PartialOrd + Clone + 'static>(
        xs: List_::List<T>,
        ys: List_::List<T>,
    ) -> i32 {
        List_::compareWith(
            Lrc::new(move |e: T, e_1: T| compare(e.clone(), e_1.clone())),
            xs,
            ys,
        )
    }
    pub fn equals<T: Eq + core::hash::Hash + Clone + 'static>(
        xs: List_::List<T>,
        ys: List_::List<T>,
    ) -> bool {
        let xs: MutCell<List_::List<T>> = MutCell::new(xs.clone());
        let ys: MutCell<List_::List<T>> = MutCell::new(ys.clone());
        '_equals: loop {
            break '_equals ({
                let matchValue: bool = List_::isEmpty(xs.get());
                let matchValue_1: bool = List_::isEmpty(ys.get());
                if matchValue {
                    if matchValue_1 {
                        true
                    } else {
                        false
                    }
                } else {
                    if matchValue_1 {
                        false
                    } else {
                        if List_::head(xs.get()) == List_::head(ys.get()) {
                            let xs_temp: List_::List<T> = List_::tail(xs.get());
                            let ys_temp: List_::List<T> = List_::tail(ys.get());
                            xs.set(xs_temp);
                            ys.set(ys_temp);
                            continue '_equals;
                        } else {
                            false
                        }
                    }
                }
            });
        }
    }
    pub fn exists<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        xs: List_::List<T>,
    ) -> bool {
        let predicate = MutCell::new(predicate.clone());
        let xs: MutCell<List_::List<T>> = MutCell::new(xs.clone());
        '_exists: loop {
            break '_exists (if List_::isEmpty(xs.get()) {
                false
            } else {
                if predicate(List_::head(xs.get())) {
                    true
                } else {
                    let predicate_temp = predicate.get();
                    let xs_temp: List_::List<T> = List_::tail(xs.get());
                    predicate.set(predicate_temp);
                    xs.set(xs_temp);
                    continue '_exists;
                }
            });
        }
    }
    pub fn exists2<T1: Clone + 'static, T2: Clone + 'static>(
        predicate: Lrc<dyn Fn(T1, T2) -> (bool) + 'static>,
        xs: List_::List<T1>,
        ys: List_::List<T2>,
    ) -> bool {
        let predicate = MutCell::new(predicate.clone());
        let xs: MutCell<List_::List<T1>> = MutCell::new(xs.clone());
        let ys: MutCell<List_::List<T2>> = MutCell::new(ys.clone());
        '_exists2: loop {
            break '_exists2 ({
                let matchValue: bool = List_::isEmpty(xs.get());
                let matchValue_1: bool = List_::isEmpty(ys.get());
                if matchValue {
                    if matchValue_1 {
                        false
                    } else {
                        panic!(
                            "{}",
                            append_1(
                                append_1(
                                    SR::listsHadDifferentLengths(),
                                    string("\\nParameter name: ")
                                ),
                                string("list2")
                            )
                        )
                    }
                } else {
                    if matchValue_1 {
                        panic!(
                            "{}",
                            append_1(
                                append_1(
                                    SR::listsHadDifferentLengths(),
                                    string("\\nParameter name: ")
                                ),
                                string("list2")
                            )
                        )
                    } else {
                        if predicate(List_::head(xs.get()), List_::head(ys.get())) {
                            true
                        } else {
                            let predicate_temp = predicate.get();
                            let xs_temp: List_::List<T1> = List_::tail(xs.get());
                            let ys_temp: List_::List<T2> = List_::tail(ys.get());
                            predicate.set(predicate_temp);
                            xs.set(xs_temp);
                            ys.set(ys_temp);
                            continue '_exists2;
                        }
                    }
                }
            });
        }
    }
    pub fn contains<T: Eq + core::hash::Hash + Clone + 'static>(
        value: T,
        xs: List_::List<T>,
    ) -> bool {
        List_::exists(
            Lrc::new({
                let value = value.clone();
                move |x: T| x.clone() == value.clone()
            }),
            xs,
        )
    }
    pub fn filter<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        xs: List_::List<T>,
    ) -> List_::List<T> {
        List_::choose(
            Lrc::new({
                let predicate = predicate.clone();
                move |x: T| {
                    if predicate(x.clone()) {
                        Some(x.clone())
                    } else {
                        None::<T>
                    }
                }
            }),
            xs,
        )
    }
    pub fn map<T: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<dyn Fn(T) -> (U) + 'static>,
        xs: List_::List<T>,
    ) -> List_::List<U> {
        let gen = Lrc::new({
            let mapping = mapping.clone();
            move |xs_1: List_::List<T>| {
                if List_::isEmpty(xs_1.clone()) {
                    None::<Lrc<(U, List_::List<T>)>>
                } else {
                    Some(Lrc::new((
                        mapping(List_::head(xs_1.clone())),
                        List_::tail(xs_1.clone()),
                    )))
                }
            }
        });
        List_::unfold(gen, xs)
    }
    pub fn mapIndexed<T: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<dyn Fn(i32, T) -> (U) + 'static>,
        xs: List_::List<T>,
    ) -> List_::List<U> {
        let gen = Lrc::new({
            let mapping = mapping.clone();
            move |tupledArg: Lrc<(i32, List_::List<T>)>| {
                let i: i32 = tupledArg.0.clone();
                let xs_1: List_::List<T> = tupledArg.1.clone();
                if List_::isEmpty(xs_1.clone()) {
                    None::<Lrc<(U, Lrc<(i32, List_::List<T>)>)>>
                } else {
                    Some(Lrc::new((
                        mapping(i, List_::head(xs_1.clone())),
                        Lrc::new((i + 1i32, List_::tail(xs_1.clone()))),
                    )))
                }
            }
        });
        List_::unfold(gen, Lrc::new((0i32, xs)))
    }
    pub fn collect<T: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<dyn Fn(T) -> (List_::List<U>) + 'static>,
        xs: List_::List<T>,
    ) -> List_::List<U> {
        let root: MutCell<Option<Lrc<List_::Node_1<U>>>> =
            MutCell::new(None::<Lrc<List_::Node_1<U>>>);
        let node: MutCell<Option<Lrc<List_::Node_1<U>>>> = MutCell::new(root.get().clone());
        let xs_1: MutCell<List_::List<T>> = MutCell::new(xs);
        let ys: MutCell<List_::List<U>> = MutCell::new(List_::empty());
        while !List_::isEmpty(xs_1.get().clone()) {
            ys.set(mapping(List_::head(xs_1.get().clone())));
            while !List_::isEmpty(ys.get().clone()) {
                node.set({
                    let node_1: Option<Lrc<List_::Node_1<U>>> = node.get().clone();
                    List_::appendConsNoTail(List_::head(ys.get().clone()), node_1)
                });
                if root.get().is_none() {
                    root.set(node.get().clone());
                }
                ys.set(List_::tail(ys.get().clone()))
            }
            xs_1.set(List_::tail(xs_1.get().clone()))
        }
        List_::mkList(root.get())
    }
    pub fn indexed<T: Clone + 'static>(xs: List_::List<T>) -> List_::List<Lrc<(i32, T)>> {
        List_::mapIndexed(Lrc::new(move |i: i32, x: T| Lrc::new((i, x.clone()))), xs)
    }
    pub fn map2<T1: Clone + 'static, T2: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<dyn Fn(T1, T2) -> (U) + 'static>,
        xs: List_::List<T1>,
        ys: List_::List<T2>,
    ) -> List_::List<U> {
        let gen = Lrc::new({
            let mapping = mapping.clone();
            move |tupledArg: Lrc<(List_::List<T1>, List_::List<T2>)>| {
                let xs_1: List_::List<T1> = tupledArg.0.clone();
                let ys_1: List_::List<T2> = tupledArg.1.clone();
                if if List_::isEmpty(xs_1.clone()) {
                    true
                } else {
                    List_::isEmpty(ys_1.clone())
                } {
                    None::<Lrc<(U, Lrc<(List_::List<T1>, List_::List<T2>)>)>>
                } else {
                    Some(Lrc::new((
                        mapping(List_::head(xs_1.clone()), List_::head(ys_1.clone())),
                        Lrc::new((List_::tail(xs_1.clone()), List_::tail(ys_1.clone()))),
                    )))
                }
            }
        });
        List_::unfold(gen, Lrc::new((xs, ys)))
    }
    pub fn mapIndexed2<T1: Clone + 'static, T2: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<dyn Fn(i32, T1, T2) -> (U) + 'static>,
        xs: List_::List<T1>,
        ys: List_::List<T2>,
    ) -> List_::List<U> {
        let gen = Lrc::new({
            let mapping = mapping.clone();
            move |tupledArg: Lrc<(i32, List_::List<T1>, List_::List<T2>)>| {
                let i: i32 = tupledArg.0.clone();
                let xs_1: List_::List<T1> = tupledArg.1.clone();
                let ys_1: List_::List<T2> = tupledArg.2.clone();
                if if List_::isEmpty(xs_1.clone()) {
                    true
                } else {
                    List_::isEmpty(ys_1.clone())
                } {
                    None::<Lrc<(U, Lrc<(i32, List_::List<T1>, List_::List<T2>)>)>>
                } else {
                    Some(Lrc::new((
                        mapping(i, List_::head(xs_1.clone()), List_::head(ys_1.clone())),
                        Lrc::new((
                            i + 1i32,
                            List_::tail(xs_1.clone()),
                            List_::tail(ys_1.clone()),
                        )),
                    )))
                }
            }
        });
        List_::unfold(gen, Lrc::new((0i32, xs, ys)))
    }
    pub fn map3<
        T1: Clone + 'static,
        T2: Clone + 'static,
        T3: Clone + 'static,
        U: Clone + 'static,
    >(
        mapping: Lrc<dyn Fn(T1, T2, T3) -> (U) + 'static>,
        xs: List_::List<T1>,
        ys: List_::List<T2>,
        zs: List_::List<T3>,
    ) -> List_::List<U> {
        let gen = Lrc::new({
            let mapping = mapping.clone();
            move |tupledArg: Lrc<(List_::List<T1>, List_::List<T2>, List_::List<T3>)>| {
                let xs_1: List_::List<T1> = tupledArg.0.clone();
                let ys_1: List_::List<T2> = tupledArg.1.clone();
                let zs_1: List_::List<T3> = tupledArg.2.clone();
                if if if List_::isEmpty(xs_1.clone()) {
                    true
                } else {
                    List_::isEmpty(ys_1.clone())
                } {
                    true
                } else {
                    List_::isEmpty(zs_1.clone())
                } {
                    None::<Lrc<(U, Lrc<(List_::List<T1>, List_::List<T2>, List_::List<T3>)>)>>
                } else {
                    Some(Lrc::new((
                        mapping(
                            List_::head(xs_1.clone()),
                            List_::head(ys_1.clone()),
                            List_::head(zs_1.clone()),
                        ),
                        Lrc::new((
                            List_::tail(xs_1.clone()),
                            List_::tail(ys_1.clone()),
                            List_::tail(zs_1.clone()),
                        )),
                    )))
                }
            }
        });
        List_::unfold(gen, Lrc::new((xs, ys, zs)))
    }
    pub fn mapFold<State: Clone + 'static, T: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<dyn Fn(State, T) -> (Lrc<(U, State)>) + 'static>,
        state: State,
        xs: List_::List<T>,
    ) -> Lrc<(List_::List<U>, State)> {
        let acc: Lrc<MutCell<State>> = Lrc::new(MutCell::new(state));
        let gen = Lrc::new({
            let acc = acc.clone();
            let mapping = mapping.clone();
            move |xs_1: List_::List<T>| {
                if List_::isEmpty(xs_1.clone()) {
                    None::<Lrc<(U, List_::List<T>)>>
                } else {
                    let m: Lrc<(U, State)> = mapping(acc.get().clone(), List_::head(xs_1.clone()));
                    acc.set(m.1.clone());
                    Some(Lrc::new((m.0.clone(), List_::tail(xs_1.clone()))))
                }
            }
        });
        Lrc::new((List_::unfold(gen, xs), acc.get().clone()))
    }
    pub fn mapFoldBack<T: Clone + 'static, State: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<dyn Fn(T, State) -> (Lrc<(U, State)>) + 'static>,
        xs: List_::List<T>,
        state: State,
    ) -> Lrc<(List_::List<U>, State)> {
        let ys: Lrc<MutCell<List_::List<U>>> = Lrc::new(MutCell::new(List_::empty()));
        let folder = Lrc::new({
            let mapping = mapping.clone();
            let ys = ys.clone();
            move |acc: State, x: T| {
                let m: Lrc<(U, State)> = mapping(x.clone(), acc.clone());
                ys.set(List_::cons(m.0.clone(), ys.get().clone()));
                m.1.clone()
            }
        });
        let st: State = List_::fold(folder, state, List_::reverse(xs));
        Lrc::new((ys.get().clone(), st))
    }
    pub fn tryPick<T: Clone + 'static, U: Clone + 'static>(
        chooser: Lrc<dyn Fn(T) -> (Option<U>) + 'static>,
        xs: List_::List<T>,
    ) -> Option<U> {
        fn inner_loop<T: Clone + 'static, U: Clone + 'static>(
            chooser_1: Lrc<dyn Fn(T) -> (Option<U>) + 'static>,
            xs_1: List_::List<T>,
        ) -> Option<U> {
            let chooser_1 = MutCell::new(chooser_1.clone());
            let xs_1: MutCell<List_::List<T>> = MutCell::new(xs_1.clone());
            '_inner_loop: loop {
                break '_inner_loop (if List_::isEmpty(xs_1.get()) {
                    None::<U>
                } else {
                    let matchValue: Option<U> = chooser_1(List_::head(xs_1.get()));
                    match &matchValue {
                        None => {
                            let chooser_1_temp = chooser_1.get();
                            let xs_1_temp: List_::List<T> = List_::tail(xs_1.get());
                            chooser_1.set(chooser_1_temp);
                            xs_1.set(xs_1_temp);
                            continue '_inner_loop;
                        }
                        _ => matchValue.clone(),
                    }
                });
            }
        }
        inner_loop(chooser, xs)
    }
    pub fn pick<T: Clone + 'static, U: Clone + 'static>(
        chooser: Lrc<dyn Fn(T) -> (Option<U>) + 'static>,
        xs: List_::List<T>,
    ) -> U {
        let matchValue: Option<U> = List_::tryPick(chooser, xs);
        match &matchValue {
            None => panic!("{}", SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn tryFind<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        xs: List_::List<T>,
    ) -> Option<T> {
        List_::tryPick(
            Lrc::new({
                let predicate = predicate.clone();
                move |x: T| {
                    if predicate(x.clone()) {
                        Some(x.clone())
                    } else {
                        None::<T>
                    }
                }
            }),
            xs,
        )
    }
    pub fn find<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        xs: List_::List<T>,
    ) -> T {
        let matchValue: Option<T> = List_::tryFind(predicate, xs);
        match &matchValue {
            None => panic!("{}", SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn tryFindBack<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        xs: List_::List<T>,
    ) -> Option<T> {
        tryFindBack_1(predicate, List_::toArray(xs))
    }
    pub fn findBack<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        xs: List_::List<T>,
    ) -> T {
        let matchValue: Option<T> = List_::tryFindBack(predicate, xs);
        match &matchValue {
            None => panic!("{}", SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn tryFindIndex<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        xs: List_::List<T>,
    ) -> Option<i32> {
        fn inner_loop<T: Clone + 'static>(
            i: i32,
            predicate_1: Lrc<dyn Fn(T) -> (bool) + 'static>,
            xs_1: List_::List<T>,
        ) -> Option<i32> {
            let i: MutCell<i32> = MutCell::new(i);
            let predicate_1 = MutCell::new(predicate_1.clone());
            let xs_1: MutCell<List_::List<T>> = MutCell::new(xs_1.clone());
            '_inner_loop: loop {
                break '_inner_loop (if List_::isEmpty(xs_1.get()) {
                    None::<i32>
                } else {
                    if predicate_1(List_::head(xs_1.get())) {
                        Some(i.get())
                    } else {
                        let i_temp: i32 = i.get() + 1i32;
                        let predicate_1_temp = predicate_1.get();
                        let xs_1_temp: List_::List<T> = List_::tail(xs_1.get());
                        i.set(i_temp);
                        predicate_1.set(predicate_1_temp);
                        xs_1.set(xs_1_temp);
                        continue '_inner_loop;
                    }
                });
            }
        }
        inner_loop(0i32, predicate, xs)
    }
    pub fn findIndex<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        xs: List_::List<T>,
    ) -> i32 {
        let matchValue: Option<i32> = List_::tryFindIndex(predicate, xs);
        match &matchValue {
            None => panic!("{}", SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn tryFindIndexBack<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        xs: List_::List<T>,
    ) -> Option<i32> {
        tryFindIndexBack_1(predicate, List_::toArray(xs))
    }
    pub fn findIndexBack<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        xs: List_::List<T>,
    ) -> i32 {
        let matchValue: Option<i32> = List_::tryFindIndexBack(predicate, xs);
        match &matchValue {
            None => panic!("{}", SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn tryItem<T: Clone + 'static>(index: i32, xs: List_::List<T>) -> Option<T> {
        fn inner_loop<T: Clone + 'static>(i: i32, xs_1: List_::List<T>) -> Option<T> {
            let i: MutCell<i32> = MutCell::new(i);
            let xs_1: MutCell<List_::List<T>> = MutCell::new(xs_1.clone());
            '_inner_loop: loop {
                break '_inner_loop (if List_::isEmpty(xs_1.get()) {
                    None::<T>
                } else {
                    if i.get() == 0i32 {
                        Some(List_::head(xs_1.get()))
                    } else {
                        if i.get() < 0i32 {
                            None::<T>
                        } else {
                            let i_temp: i32 = i.get() - 1i32;
                            let xs_1_temp: List_::List<T> = List_::tail(xs_1.get());
                            i.set(i_temp);
                            xs_1.set(xs_1_temp);
                            continue '_inner_loop;
                        }
                    }
                });
            }
        }
        inner_loop(index, xs)
    }
    pub fn item<T: Clone + 'static>(index: i32, xs: List_::List<T>) -> T {
        let matchValue: Option<T> = List_::tryItem(index, xs);
        match &matchValue {
            Some(matchValue_0_0) => matchValue_0_0.clone(),
            _ => panic!(
                "{}",
                append_1(
                    append_1(SR::indexOutOfBounds(), string("\\nParameter name: ")),
                    string("index")
                )
            ),
        }
    }
    pub fn initialize<T: Clone + 'static>(
        count: i32,
        initializer: Lrc<dyn Fn(i32) -> (T) + 'static>,
    ) -> List_::List<T> {
        let gen = Lrc::new({
            let count = count.clone();
            let initializer = initializer.clone();
            move |i: i32| {
                if i < count {
                    Some(Lrc::new((initializer(i), i + 1i32)))
                } else {
                    None::<Lrc<(T, i32)>>
                }
            }
        });
        List_::unfold(gen, 0i32)
    }
    pub fn pairwise<T: Clone + 'static>(xs: List_::List<T>) -> List_::List<Lrc<(T, T)>> {
        List_::ofArray(pairwise_1(List_::toArray(xs)))
    }
    pub fn partition<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        xs: List_::List<T>,
    ) -> Lrc<(List_::List<T>, List_::List<T>)> {
        let root1: MutCell<Option<Lrc<List_::Node_1<T>>>> =
            MutCell::new(None::<Lrc<List_::Node_1<T>>>);
        let root2: MutCell<Option<Lrc<List_::Node_1<T>>>> =
            MutCell::new(None::<Lrc<List_::Node_1<T>>>);
        let node1: MutCell<Option<Lrc<List_::Node_1<T>>>> = MutCell::new(root1.get().clone());
        let node2: MutCell<Option<Lrc<List_::Node_1<T>>>> = MutCell::new(root2.get().clone());
        let xs_1: MutCell<List_::List<T>> = MutCell::new(xs);
        while !List_::isEmpty(xs_1.get().clone()) {
            let x: T = List_::head(xs_1.get().clone());
            if predicate(x.clone()) {
                node1.set(List_::appendConsNoTail(x.clone(), node1.get().clone()));
                if root1.get().is_none() {
                    root1.set(node1.get().clone());
                }
            } else {
                node2.set(List_::appendConsNoTail(x.clone(), node2.get().clone()));
                if root2.get().is_none() {
                    root2.set(node2.get().clone());
                }
            }
            xs_1.set(List_::tail(xs_1.get().clone()))
        }
        Lrc::new((List_::mkList(root1.get()), List_::mkList(root2.get())))
    }
    pub fn reduce<T: Clone + 'static>(
        reduction: Lrc<dyn Fn(T, T) -> (T) + 'static>,
        xs: List_::List<T>,
    ) -> T {
        if List_::isEmpty(xs.clone()) {
            panic!("{}", SR::inputListWasEmpty());
        }
        List_::fold(reduction, List_::head(xs.clone()), List_::tail(xs))
    }
    pub fn reduceBack<T: Clone + 'static>(
        reduction: Lrc<dyn Fn(T, T) -> (T) + 'static>,
        xs: List_::List<T>,
    ) -> T {
        if List_::isEmpty(xs.clone()) {
            panic!("{}", SR::inputListWasEmpty());
        }
        List_::foldBack(reduction, List_::tail(xs.clone()), List_::head(xs))
    }
    pub fn replicate<T: Clone + 'static>(count: i32, initial: T) -> List_::List<T> {
        List_::initialize(
            count,
            Lrc::new({
                let initial = initial.clone();
                move |_arg: i32| initial.clone()
            }),
        )
    }
    pub fn unzip<_a: Clone + 'static, _b: Clone + 'static>(
        xs: List_::List<Lrc<(_a, _b)>>,
    ) -> Lrc<(List_::List<_a>, List_::List<_b>)> {
        List_::foldBack(
            Lrc::new(
                move |tupledArg: Lrc<(_a, _b)>,
                      tupledArg_1: Lrc<(List_::List<_a>, List_::List<_b>)>| {
                    Lrc::new((
                        List_::cons(tupledArg.0.clone(), tupledArg_1.0.clone()),
                        List_::cons(tupledArg.1.clone(), tupledArg_1.1.clone()),
                    ))
                },
            ),
            xs,
            Lrc::new((List_::empty(), List_::empty())),
        )
    }
    pub fn unzip3<_a: Clone + 'static, _b: Clone + 'static, _c: Clone + 'static>(
        xs: List_::List<Lrc<(_a, _b, _c)>>,
    ) -> Lrc<(List_::List<_a>, List_::List<_b>, List_::List<_c>)> {
        List_::foldBack(Lrc::new(move
                                     |tupledArg: Lrc<(_a, _b, _c)>,
                                      tupledArg_1:
                                          Lrc<(List_::List<_a>,
                                               List_::List<_b>,
                                               List_::List<_c>)>|
                                     Lrc::new((List_::cons(tupledArg.0.clone(),
                                                           tupledArg_1.0.clone()),
                                               List_::cons(tupledArg.1.clone(),
                                                           tupledArg_1.1.clone()),
                                               List_::cons(tupledArg.2.clone(),
                                                           tupledArg_1.2.clone())))),
                        xs,
                        Lrc::new((List_::empty(), List_::empty(),
                                  List_::empty())))
    }
    pub fn zip<_a: Clone + 'static, _b: Clone + 'static>(
        xs: List_::List<_a>,
        ys: List_::List<_b>,
    ) -> List_::List<Lrc<(_a, _b)>> {
        List_::map2(
            Lrc::new(move |x: _a, y: _b| Lrc::new((x.clone(), y.clone()))),
            xs,
            ys,
        )
    }
    pub fn zip3<_a: Clone + 'static, _b: Clone + 'static, _c: Clone + 'static>(
        xs: List_::List<_a>,
        ys: List_::List<_b>,
        zs: List_::List<_c>,
    ) -> List_::List<Lrc<(_a, _b, _c)>> {
        List_::map3(
            Lrc::new(move |x: _a, y: _b, z: _c| Lrc::new((x.clone(), y.clone(), z.clone()))),
            xs,
            ys,
            zs,
        )
    }
    pub fn sortWith<T: Clone + 'static>(
        comparer: Lrc<dyn Fn(T, T) -> (i32) + 'static>,
        xs: List_::List<T>,
    ) -> List_::List<T> {
        let arr: Array<T> = List_::toArray(xs);
        sortInPlaceWith(comparer, arr.clone());
        List_::ofArray(arr)
    }
    pub fn sort<T: PartialOrd + Clone + 'static>(xs: List_::List<T>) -> List_::List<T> {
        List_::sortWith(
            Lrc::new(move |e: T, e_1: T| compare(e.clone(), e_1.clone())),
            xs,
        )
    }
    pub fn sortBy<T: Clone + 'static, U: PartialOrd + Clone + 'static>(
        projection: Lrc<dyn Fn(T) -> (U) + 'static>,
        xs: List_::List<T>,
    ) -> List_::List<T> {
        List_::sortWith(
            Lrc::new({
                let projection = projection.clone();
                move |x: T, y: T| compare(projection(x.clone()), projection(y.clone()))
            }),
            xs,
        )
    }
    pub fn sortDescending<T: PartialOrd + Clone + 'static>(xs: List_::List<T>) -> List_::List<T> {
        List_::sortWith(
            Lrc::new(move |x: T, y: T| compare(x.clone(), y.clone()) * -1i32),
            xs,
        )
    }
    pub fn sortByDescending<T: Clone + 'static, U: PartialOrd + Clone + 'static>(
        projection: Lrc<dyn Fn(T) -> (U) + 'static>,
        xs: List_::List<T>,
    ) -> List_::List<T> {
        List_::sortWith(
            Lrc::new({
                let projection = projection.clone();
                move |x: T, y: T| compare(projection(x.clone()), projection(y.clone())) * -1i32
            }),
            xs,
        )
    }
    pub fn sum<T: core::ops::Add<Output = T> + Default + Clone + 'static>(xs: List_::List<T>) -> T {
        List_::fold(
            Lrc::new(move |acc: T, x: T| acc.clone() + x.clone()),
            getZero::<T>(),
            xs,
        )
    }
    pub fn sumBy<T: Clone + 'static, U: core::ops::Add<Output = U> + Default + Clone + 'static>(
        projection: Lrc<dyn Fn(T) -> (U) + 'static>,
        xs: List_::List<T>,
    ) -> U {
        List_::fold(
            Lrc::new({
                let projection = projection.clone();
                move |acc: U, x: T| acc.clone() + projection(x.clone())
            }),
            getZero::<U>(),
            xs,
        )
    }
    pub fn maxBy<T: Clone + 'static, U: PartialOrd + Clone + 'static>(
        projection: Lrc<dyn Fn(T) -> (U) + 'static>,
        xs: List_::List<T>,
    ) -> T {
        List_::reduce(
            Lrc::new({
                let projection = projection.clone();
                move |x: T, y: T| {
                    if projection(x.clone()) > projection(y.clone()) {
                        x.clone()
                    } else {
                        y.clone()
                    }
                }
            }),
            xs,
        )
    }
    pub fn max<T: PartialOrd + Clone + 'static>(xs: List_::List<T>) -> T {
        List_::reduce(
            Lrc::new(move |x: T, y: T| {
                if x.clone() > y.clone() {
                    x.clone()
                } else {
                    y.clone()
                }
            }),
            xs,
        )
    }
    pub fn minBy<T: Clone + 'static, U: PartialOrd + Clone + 'static>(
        projection: Lrc<dyn Fn(T) -> (U) + 'static>,
        xs: List_::List<T>,
    ) -> T {
        List_::reduce(
            Lrc::new({
                let projection = projection.clone();
                move |x: T, y: T| {
                    if projection(x.clone()) < projection(y.clone()) {
                        x.clone()
                    } else {
                        y.clone()
                    }
                }
            }),
            xs,
        )
    }
    pub fn min<T: PartialOrd + Clone + 'static>(xs: List_::List<T>) -> T {
        List_::reduce(
            Lrc::new(move |x: T, y: T| {
                if x.clone() < y.clone() {
                    x.clone()
                } else {
                    y.clone()
                }
            }),
            xs,
        )
    }
    pub fn average<
        T: core::ops::Add<Output = T>
            + core::ops::Div<Output = T>
            + From<i32>
            + Default
            + Clone
            + 'static,
    >(
        xs: List_::List<T>,
    ) -> T {
        if List_::isEmpty(xs.clone()) {
            panic!("{}", SR::inputListWasEmpty());
        }
        {
            let count: Lrc<MutCell<i32>> = Lrc::new(MutCell::new(0i32));
            let folder = Lrc::new({
                let count = count.clone();
                move |acc: T, x: T| {
                    count.set(count.get() + 1i32);
                    acc.clone() + x.clone()
                }
            });
            List_::fold(folder, getZero::<T>(), xs) / T::from(count.get()).clone()
        }
    }
    pub fn averageBy<
        T: Clone + 'static,
        U: core::ops::Add<Output = U>
            + core::ops::Div<Output = U>
            + From<i32>
            + Default
            + Clone
            + 'static,
    >(
        projection: Lrc<dyn Fn(T) -> (U) + 'static>,
        xs: List_::List<T>,
    ) -> U {
        if List_::isEmpty(xs.clone()) {
            panic!("{}", SR::inputListWasEmpty());
        }
        {
            let count: Lrc<MutCell<i32>> = Lrc::new(MutCell::new(0i32));
            let folder = Lrc::new({
                let count = count.clone();
                let projection = projection.clone();
                move |acc: U, x: T| {
                    count.set(count.get() + 1i32);
                    acc.clone() + projection(x.clone())
                }
            });
            List_::fold(folder, getZero::<U>(), xs) / U::from(count.get()).clone()
        }
    }
    pub fn permute<T: Clone + 'static>(
        indexMap: Lrc<dyn Fn(i32) -> (i32) + 'static>,
        xs: List_::List<T>,
    ) -> List_::List<T> {
        List_::ofArray(permute_1(indexMap, List_::toArray(xs)))
    }
    pub fn chunkBySize<T: Clone + 'static>(
        chunkSize: i32,
        xs: List_::List<T>,
    ) -> List_::List<List_::List<T>> {
        List_::ofArray(map_1(
            Lrc::new(move |xs_2: Array<T>| List_::ofArray(xs_2.clone())),
            chunkBySize_1(chunkSize, List_::toArray(xs)),
        ))
    }
    pub fn allPairs<T1: Clone + 'static, T2: Clone + 'static>(
        xs: List_::List<T1>,
        ys: List_::List<T2>,
    ) -> List_::List<Lrc<(T1, T2)>> {
        let root: Lrc<MutCell<Option<Lrc<List_::Node_1<Lrc<(T1, T2)>>>>>> =
            Lrc::new(MutCell::new(None::<Lrc<List_::Node_1<Lrc<(T1, T2)>>>>));
        let node: Lrc<MutCell<Option<Lrc<List_::Node_1<Lrc<(T1, T2)>>>>>> =
            Lrc::new(MutCell::new(root.get().clone()));
        List_::iterate(
            Lrc::new({
                let node = node.clone();
                let root = root.clone();
                let ys = ys.clone();
                move |x: T1| {
                    List_::iterate(
                        Lrc::new({
                            let node = node.clone();
                            let root = root.clone();
                            let x = x.clone();
                            move |y: T2| {
                                node.set(List_::appendConsNoTail(
                                    Lrc::new((x.clone(), y.clone())),
                                    node.get().clone(),
                                ));
                                if root.get().is_none() {
                                    root.set(node.get().clone());
                                }
                            }
                        }),
                        ys.clone(),
                    )
                }
            }),
            xs,
        );
        List_::mkList(root.get().clone())
    }
    pub fn scan<State: Clone + 'static, T: Clone + 'static>(
        folder: Lrc<dyn Fn(State, T) -> (State) + 'static>,
        state: State,
        xs: List_::List<T>,
    ) -> List_::List<State> {
        List_::ofArray(scan_1(folder, state, List_::toArray(xs)))
    }
    pub fn scanBack<T: Clone + 'static, State: Clone + 'static>(
        folder: Lrc<dyn Fn(T, State) -> (State) + 'static>,
        xs: List_::List<T>,
        state: State,
    ) -> List_::List<State> {
        List_::ofArray(scanBack_1(folder, List_::toArray(xs), state))
    }
    pub fn skip<T: Clone + 'static>(count: i32, xs: List_::List<T>) -> List_::List<T> {
        let count: MutCell<i32> = MutCell::new(count);
        let xs: MutCell<List_::List<T>> = MutCell::new(xs.clone());
        '_skip: loop {
            break '_skip (if count.get() <= 0i32 {
                xs.get()
            } else {
                if List_::isEmpty(xs.get()) {
                    panic!(
                        "{}",
                        append_1(
                            append_1(SR::notEnoughElements(), string("\\nParameter name: ")),
                            string("list")
                        )
                    );
                }
                {
                    let count_temp: i32 = count.get() - 1i32;
                    let xs_temp: List_::List<T> = List_::tail(xs.get());
                    count.set(count_temp);
                    xs.set(xs_temp);
                    continue '_skip;
                }
            });
        }
    }
    pub fn skipSafe<T: Clone + 'static>(count: i32, xs: List_::List<T>) -> List_::List<T> {
        let count: MutCell<i32> = MutCell::new(count);
        let xs: MutCell<List_::List<T>> = MutCell::new(xs.clone());
        '_skipSafe: loop {
            break '_skipSafe (if if count.get() <= 0i32 {
                true
            } else {
                List_::isEmpty(xs.get())
            } {
                xs.get()
            } else {
                let count_temp: i32 = count.get() - 1i32;
                let xs_temp: List_::List<T> = List_::tail(xs.get());
                count.set(count_temp);
                xs.set(xs_temp);
                continue '_skipSafe;
            });
        }
    }
    pub fn skipWhile<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        xs: List_::List<T>,
    ) -> List_::List<T> {
        let predicate = MutCell::new(predicate.clone());
        let xs: MutCell<List_::List<T>> = MutCell::new(xs.clone());
        '_skipWhile: loop {
            break '_skipWhile (if List_::isEmpty(xs.get()) {
                xs.get()
            } else {
                if !predicate(List_::head(xs.get())) {
                    xs.get()
                } else {
                    let predicate_temp = predicate.get();
                    let xs_temp: List_::List<T> = List_::tail(xs.get());
                    predicate.set(predicate_temp);
                    xs.set(xs_temp);
                    continue '_skipWhile;
                }
            });
        }
    }
    pub fn take<T: Clone + 'static>(count: i32, xs: List_::List<T>) -> List_::List<T> {
        if count < 0i32 {
            panic!(
                "{}",
                append_1(
                    append_1(SR::inputMustBeNonNegative(), string("\\nParameter name: ")),
                    string("count")
                )
            );
        }
        {
            fn gen<T: Clone + 'static>(
                tupledArg: Lrc<(i32, List_::List<T>)>,
            ) -> Option<Lrc<(T, Lrc<(i32, List_::List<T>)>)>> {
                let i: i32 = tupledArg.0.clone();
                let xs_1: List_::List<T> = tupledArg.1.clone();
                if i > 0i32 {
                    if List_::isEmpty(xs_1.clone()) {
                        panic!(
                            "{}",
                            append_1(
                                append_1(SR::notEnoughElements(), string("\\nParameter name: ")),
                                string("list")
                            )
                        );
                    }
                    Some(Lrc::new((
                        List_::head(xs_1.clone()),
                        Lrc::new((i - 1i32, List_::tail(xs_1))),
                    )))
                } else {
                    None::<Lrc<(T, Lrc<(i32, List_::List<T>)>)>>
                }
            }
            List_::unfold(Lrc::new(gen).clone(), Lrc::new((count, xs)))
        }
    }
    pub fn takeWhile<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        xs: List_::List<T>,
    ) -> List_::List<T> {
        let gen = Lrc::new({
            let predicate = predicate.clone();
            move |xs_1: List_::List<T>| {
                if if !List_::isEmpty(xs_1.clone()) {
                    predicate(List_::head(xs_1.clone()))
                } else {
                    false
                } {
                    Some(Lrc::new((
                        List_::head(xs_1.clone()),
                        List_::tail(xs_1.clone()),
                    )))
                } else {
                    None::<Lrc<(T, List_::List<T>)>>
                }
            }
        });
        List_::unfold(gen, xs)
    }
    pub fn truncate<T: Clone + 'static>(count: i32, xs: List_::List<T>) -> List_::List<T> {
        fn gen<T: Clone + 'static>(
            tupledArg: Lrc<(i32, List_::List<T>)>,
        ) -> Option<Lrc<(T, Lrc<(i32, List_::List<T>)>)>> {
            let i: i32 = tupledArg.0.clone();
            let xs_1: List_::List<T> = tupledArg.1.clone();
            if if i > 0i32 {
                !List_::isEmpty(xs_1.clone())
            } else {
                false
            } {
                Some(Lrc::new((
                    List_::head(xs_1.clone()),
                    Lrc::new((i - 1i32, List_::tail(xs_1))),
                )))
            } else {
                None::<Lrc<(T, Lrc<(i32, List_::List<T>)>)>>
            }
        }
        List_::unfold(Lrc::new(gen).clone(), Lrc::new((count, xs)))
    }
    pub fn getSlice<T: Clone + 'static>(
        lower: Option<i32>,
        upper: Option<i32>,
        xs: List_::List<T>,
    ) -> List_::List<T> {
        if lower.is_some() {
            if upper.is_some() {
                let start_1: i32 = getValue(lower.clone());
                let stop_1: i32 = getValue(upper.clone());
                List_::truncate(
                    stop_1 - start_1 + 1i32,
                    List_::skipSafe(start_1, xs.clone()),
                )
            } else {
                let start: i32 = getValue(lower);
                List_::skipSafe(start, xs.clone())
            }
        } else {
            if upper.is_some() {
                let stop: i32 = getValue(upper);
                List_::truncate(stop + 1i32, xs.clone())
            } else {
                xs
            }
        }
    }
    pub fn splitAt<T: Clone + 'static>(
        index: i32,
        xs: List_::List<T>,
    ) -> Lrc<(List_::List<T>, List_::List<T>)> {
        if index < 0i32 {
            panic!(
                "{}",
                append_1(
                    append_1(SR::inputMustBeNonNegative(), string("\\nParameter name: ")),
                    string("index")
                )
            );
        }
        if index > List_::length(xs.clone()) {
            panic!(
                "{}",
                append_1(
                    append_1(SR::notEnoughElements(), string("\\nParameter name: ")),
                    string("index")
                )
            );
        }
        Lrc::new((List_::take(index, xs.clone()), List_::skip(index, xs)))
    }
    pub fn exactlyOne<T: Clone + 'static>(xs: List_::List<T>) -> T {
        if List_::isEmpty(xs.clone()) {
            panic!(
                "{}",
                append_1(
                    append_1(SR::inputSequenceEmpty(), string("\\nParameter name: ")),
                    string("list")
                )
            )
        } else {
            if List_::isEmpty(List_::tail(xs.clone())) {
                List_::head(xs)
            } else {
                panic!(
                    "{}",
                    append_1(
                        append_1(SR::inputSequenceTooLong(), string("\\nParameter name: ")),
                        string("list")
                    )
                )
            }
        }
    }
    pub fn tryExactlyOne<T: Clone + 'static>(xs: List_::List<T>) -> Option<T> {
        if if !List_::isEmpty(xs.clone()) {
            List_::isEmpty(List_::tail(xs.clone()))
        } else {
            false
        } {
            Some(List_::head(xs))
        } else {
            None::<T>
        }
    }
    pub fn r#where<T: Clone + 'static>(
        predicate: Lrc<dyn Fn(T) -> (bool) + 'static>,
        xs: List_::List<T>,
    ) -> List_::List<T> {
        List_::filter(predicate, xs)
    }
    pub fn windowed<T: Clone + 'static>(
        windowSize: i32,
        xs: List_::List<T>,
    ) -> List_::List<List_::List<T>> {
        List_::ofArray(map_1(
            Lrc::new(move |xs_2: Array<T>| List_::ofArray(xs_2.clone())),
            windowed_1(windowSize, List_::toArray(xs)),
        ))
    }
    pub fn splitInto<T: Clone + 'static>(
        chunks: i32,
        xs: List_::List<T>,
    ) -> List_::List<List_::List<T>> {
        List_::ofArray(map_1(
            Lrc::new(move |xs_2: Array<T>| List_::ofArray(xs_2.clone())),
            splitInto_1(chunks, List_::toArray(xs)),
        ))
    }
    pub fn transpose<T: Clone + 'static>(
        lists: List_::List<List_::List<T>>,
    ) -> List_::List<List_::List<T>> {
        if List_::isEmpty(lists.clone()) {
            List_::empty()
        } else {
            let tRows: List_::List<List_::List<T>> = List_::map(
                Lrc::new(move |x: T| List_::singleton(x.clone())),
                List_::head(lists.clone()),
            );
            let nodes: Array<Option<Lrc<List_::Node_1<T>>>> = List_::toArray(List_::map(
                Lrc::new(move |xs_1: List_::List<T>| xs_1.root.clone()),
                tRows.clone(),
            ));
            List_::iterate(
                Lrc::new({
                    let nodes = nodes.clone();
                    move |xs_5: List_::List<T>| {
                        List_::iterateIndexed(
                            Lrc::new({
                                let nodes = nodes.clone();
                                move |i: i32, x_1: T| {
                                    if i >= nodes.len() as i32 {
                                        panic!(
                                            "{}",
                                            append_1(
                                                append_1(
                                                    SR::listsHadDifferentLengths(),
                                                    string("\\nParameter name: ")
                                                ),
                                                string("lists")
                                            )
                                        );
                                    }
                                    nodes.get_mut()[i as usize] =
                                        List_::appendConsNoTail(x_1.clone(), nodes[i].clone())
                                }
                            }),
                            xs_5.clone(),
                        )
                    }
                }),
                List_::tail(lists),
            );
            tRows
        }
    }
    pub fn distinct<T: Eq + core::hash::Hash + Clone + 'static>(
        xs: List_::List<T>,
    ) -> List_::List<T> {
        let hashSet: HashSet<T> = empty_1::<T>();
        List_::filter(
            Lrc::new({
                let hashSet = hashSet.clone();
                move |x: T| hashSet.get_mut().insert(x.clone())
            }),
            xs,
        )
    }
    pub fn distinctBy<T: Clone + 'static, Key: Eq + core::hash::Hash + Clone + 'static>(
        projection: Lrc<dyn Fn(T) -> (Key) + 'static>,
        xs: List_::List<T>,
    ) -> List_::List<T> {
        let hashSet: HashSet<Key> = empty_1::<Key>();
        List_::filter(
            Lrc::new({
                let hashSet = hashSet.clone();
                let projection = projection.clone();
                move |x: T| hashSet.get_mut().insert(projection(x.clone()))
            }),
            xs,
        )
    }
    pub fn except<T: Eq + core::hash::Hash + Clone + 'static>(
        itemsToExclude: Lrc<dyn IEnumerable_1<T>>,
        xs: List_::List<T>,
    ) -> List_::List<T> {
        let hashSet: HashSet<T> = fromArray(toArray_1(itemsToExclude));
        List_::filter(
            Lrc::new({
                let hashSet = hashSet.clone();
                move |x: T| hashSet.get_mut().insert(x.clone())
            }),
            xs,
        )
    }
    pub fn countBy<T: Clone + 'static, Key: Eq + core::hash::Hash + Clone + 'static>(
        projection: Lrc<dyn Fn(T) -> (Key) + 'static>,
        xs: List_::List<T>,
    ) -> List_::List<Lrc<(Key, i32)>> {
        let dict: HashMap<Key, i32> = empty_2::<Key, i32>();
        let keys: Array<Key> = arrayEmpty::<Key>();
        List_::iterate(
            Lrc::new({
                let dict = dict.clone();
                let keys = keys.clone();
                let projection = projection.clone();
                move |x: T| {
                    let key: Key = projection(x.clone());
                    let matchValue: Lrc<(bool, i32)> = {
                        let outArg: MutCell<i32> = MutCell::new(0i32);
                        Lrc::new((
                            tryGetValue(dict.clone(), key.clone(), &outArg),
                            outArg.get(),
                        ))
                    };
                    if matchValue.0.clone() {
                        set(dict.clone(), key.clone(), matchValue.1.clone() + 1i32)
                    } else {
                        set(dict.clone(), key.clone(), 1i32);
                        keys.get_mut().push(key.clone())
                    }
                }
            }),
            xs,
        );
        List_::ofArray(map_1(
            Lrc::new({
                let dict = dict.clone();
                move |key_1: Key| Lrc::new((key_1.clone(), get(dict.clone(), key_1.clone())))
            }),
            (&keys).clone(),
        ))
    }
    pub fn groupBy<T: Clone + 'static, Key: Eq + core::hash::Hash + Clone + 'static>(
        projection: Lrc<dyn Fn(T) -> (Key) + 'static>,
        xs: List_::List<T>,
    ) -> List_::List<Lrc<(Key, List_::List<T>)>> {
        let dict: HashMap<Key, Array<T>> = empty_2::<Key, Array<T>>();
        let keys: Array<Key> = arrayEmpty::<Key>();
        List_::iterate(
            Lrc::new({
                let dict = dict.clone();
                let keys = keys.clone();
                let projection = projection.clone();
                move |x: T| {
                    let key: Key = projection(x.clone());
                    let matchValue: Lrc<(bool, Array<T>)> = {
                        let outArg: MutCell<Array<T>> = MutCell::new(arrayEmpty::<T>());
                        Lrc::new((
                            tryGetValue(dict.clone(), key.clone(), &outArg),
                            outArg.get().clone(),
                        ))
                    };
                    if matchValue.0.clone() {
                        matchValue.1.clone().get_mut().push(x.clone())
                    } else {
                        add(dict.clone(), key.clone(), array_2(&[x]));
                        keys.get_mut().push(key.clone())
                    }
                }
            }),
            xs,
        );
        List_::ofArray(map_1(
            Lrc::new({
                let dict = dict.clone();
                move |key_1: Key| {
                    Lrc::new((
                        key_1.clone(),
                        List_::ofArray((&get(dict.clone(), key_1.clone())).clone()),
                    ))
                }
            }),
            (&keys).clone(),
        ))
    }
    pub fn insertAt<T: Clone + 'static>(index: i32, y: T, xs: List_::List<T>) -> List_::List<T> {
        let i: Lrc<MutCell<i32>> = Lrc::new(MutCell::new(-1i32));
        let isDone: Lrc<MutCell<bool>> = Lrc::new(MutCell::new(false));
        let res: List_::List<T> = List_::fold(
            Lrc::new({
                let i = i.clone();
                let index = index.clone();
                let isDone = isDone.clone();
                let y = y.clone();
                move |acc: List_::List<T>, x: T| {
                    i.set(i.get() + 1i32);
                    if i.get() == index {
                        isDone.set(true);
                        List_::cons(x.clone(), List_::cons(y.clone(), acc.clone()))
                    } else {
                        List_::cons(x.clone(), acc.clone())
                    }
                }
            }),
            List_::empty(),
            xs,
        );
        List_::reverse(if isDone.get() {
            res.clone()
        } else {
            if i.get() + 1i32 == index {
                List_::cons(y.clone(), res)
            } else {
                panic!(
                    "{}",
                    append_1(
                        append_1(SR::indexOutOfBounds(), string("\\nParameter name: ")),
                        string("index")
                    )
                )
            }
        })
    }
    pub fn insertManyAt<T: Clone + 'static>(
        index: i32,
        ys: Lrc<dyn IEnumerable_1<T>>,
        xs: List_::List<T>,
    ) -> List_::List<T> {
        let i: Lrc<MutCell<i32>> = Lrc::new(MutCell::new(-1i32));
        let isDone: Lrc<MutCell<bool>> = Lrc::new(MutCell::new(false));
        let ys_1: List_::List<T> = List_::ofSeq(ys);
        let res: List_::List<T> = List_::fold(
            Lrc::new({
                let i = i.clone();
                let index = index.clone();
                let isDone = isDone.clone();
                let ys_1 = ys_1.clone();
                move |acc: List_::List<T>, x: T| {
                    i.set(i.get() + 1i32);
                    if i.get() == index {
                        isDone.set(true);
                        List_::cons(x.clone(), List_::append(ys_1.clone(), acc.clone()))
                    } else {
                        List_::cons(x.clone(), acc.clone())
                    }
                }
            }),
            List_::empty(),
            xs,
        );
        List_::reverse(if isDone.get() {
            res.clone()
        } else {
            if i.get() + 1i32 == index {
                List_::append(ys_1.clone(), res)
            } else {
                panic!(
                    "{}",
                    append_1(
                        append_1(SR::indexOutOfBounds(), string("\\nParameter name: ")),
                        string("index")
                    )
                )
            }
        })
    }
    pub fn removeAt<T: Clone + 'static>(index: i32, xs: List_::List<T>) -> List_::List<T> {
        let i: Lrc<MutCell<i32>> = Lrc::new(MutCell::new(-1i32));
        let isDone: Lrc<MutCell<bool>> = Lrc::new(MutCell::new(false));
        let res: List_::List<T> = List_::filter(
            Lrc::new({
                let i = i.clone();
                let index = index.clone();
                let isDone = isDone.clone();
                move |_arg: T| {
                    i.set(i.get() + 1i32);
                    if i.get() == index {
                        isDone.set(true);
                        false
                    } else {
                        true
                    }
                }
            }),
            xs,
        );
        if !isDone.get() {
            panic!(
                "{}",
                append_1(
                    append_1(SR::indexOutOfBounds(), string("\\nParameter name: ")),
                    string("index")
                )
            );
        }
        res
    }
    pub fn removeManyAt<T: Clone + 'static>(
        index: i32,
        count: i32,
        xs: List_::List<T>,
    ) -> List_::List<T> {
        let i: Lrc<MutCell<i32>> = Lrc::new(MutCell::new(-1i32));
        let status: Lrc<MutCell<i32>> = Lrc::new(MutCell::new(-1i32));
        let res: List_::List<T> = List_::filter(
            Lrc::new({
                let count = count.clone();
                let i = i.clone();
                let index = index.clone();
                let status = status.clone();
                move |_arg: T| {
                    i.set(i.get() + 1i32);
                    if i.get() == index {
                        status.set(0i32);
                        false
                    } else {
                        if i.get() > index {
                            if i.get() < index + count {
                                false
                            } else {
                                status.set(1i32);
                                true
                            }
                        } else {
                            true
                        }
                    }
                }
            }),
            xs,
        );
        let status_1: i32 = if if status.get() == 0i32 {
            i.get() + 1i32 == index + count
        } else {
            false
        } {
            1i32
        } else {
            status.get()
        };
        if status_1 < 1i32 {
            panic!(
                "{}",
                append_1(
                    append_1(SR::indexOutOfBounds(), string("\\nParameter name: ")),
                    (if status_1 < 0i32 {
                        string("index")
                    } else {
                        string("count")
                    })
                )
            );
        }
        res
    }
    pub fn updateAt<T: Clone + 'static>(index: i32, y: T, xs: List_::List<T>) -> List_::List<T> {
        let isDone: Lrc<MutCell<bool>> = Lrc::new(MutCell::new(false));
        let res: List_::List<T> = List_::mapIndexed(
            Lrc::new({
                let index = index.clone();
                let isDone = isDone.clone();
                let y = y.clone();
                move |i: i32, x: T| {
                    if i == index {
                        isDone.set(true);
                        y.clone()
                    } else {
                        x.clone()
                    }
                }
            }),
            xs,
        );
        if !isDone.get() {
            panic!(
                "{}",
                append_1(
                    append_1(SR::indexOutOfBounds(), string("\\nParameter name: ")),
                    string("index")
                )
            );
        }
        res
    }
}
