pub mod Set_ {
    use super::*;
    use crate::module_2031347a::Native_::arrayWithCapacity;
    use crate::module_2031347a::Native_::Array;
    use crate::module_2031347a::Native_::Lrc;
    use crate::module_2031347a::Native_::MutCell;
    use crate::module_25e675f8::Option_::getValue;
    use crate::module_264daaf9::List_::cons;
    use crate::module_264daaf9::List_::empty as empty_1;
    use crate::module_264daaf9::List_::fold as fold_3;
    use crate::module_264daaf9::List_::head;
    use crate::module_264daaf9::List_::isEmpty as isEmpty_1;
    use crate::module_264daaf9::List_::singleton as singleton_1;
    use crate::module_264daaf9::List_::tail;
    use crate::module_264daaf9::List_::List;
    use crate::module_75c81ae2::Array_::fold as fold_2;
    use crate::module_912d02ed::Interfaces_::System::Collections::Generic::IEnumerable_1;
    use crate::module_9d52c5fc::Seq_::compareWith;
    use crate::module_9d52c5fc::Seq_::delay;
    use crate::module_9d52c5fc::Seq_::fold as fold_1;
    use crate::module_9d52c5fc::Seq_::reduce;
    use crate::module_9d52c5fc::Seq_::unfold;
    use crate::module_b1128850::Global_::SR;
    use crate::module_c5a2a64e::String_::append;
    use crate::module_c5a2a64e::String_::string;
    use crate::module_d98fc69f::Util_::compare;
    #[derive(Clone, Debug, Default, Hash)]
    pub struct SetTree_1<T: Clone + 'static> {
        pub Height: i32,
        pub Key: T,
        pub Left: Set_::Set<T>,
        pub Right: Set_::Set<T>,
    }
    #[derive(Clone, Debug, Default, Hash)]
    pub struct Set<T: Clone + 'static> {
        pub root: Option<Lrc<Set_::SetTree_1<T>>>,
    }
    fn mkSet<_a: Clone + 'static>(root: Option<Lrc<Set_::SetTree_1<_a>>>) -> Set_::Set<_a> {
        Set_::Set::<_a> { root: root }
    }
    pub fn empty<T: Clone + 'static>() -> Set_::Set<T> {
        Set_::Set::<T> {
            root: None::<Lrc<Set_::SetTree_1<T>>>,
        }
    }
    pub fn isEmpty<T: Clone + 'static>(s: Set_::Set<T>) -> bool {
        s.root.is_none()
    }
    pub fn mkSetTreeLeaf<T: Clone + 'static>(key: T) -> Set_::Set<T> {
        Set_::mkSet(Some(Lrc::new(Set_::SetTree_1::<T> {
            Height: 1i32,
            Key: key,
            Left: Set_::empty(),
            Right: Set_::empty(),
        })))
    }
    pub fn mkSetTreeNode<T: Clone + 'static>(
        key: T,
        left: Set_::Set<T>,
        right: Set_::Set<T>,
        height: i32,
    ) -> Set_::Set<T> {
        Set_::mkSet(Some(Lrc::new(Set_::SetTree_1::<T> {
            Height: height,
            Key: key,
            Left: left,
            Right: right,
        })))
    }
    pub fn singleton<T: Clone + 'static>(value: T) -> Set_::Set<T> {
        Set_::mkSetTreeLeaf(value)
    }
    pub fn countAux<T: Clone + 'static>(s: Set_::Set<T>, acc: i32) -> i32 {
        let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    acc + 1i32
                } else {
                    Set_::countAux(t.Left.clone(), Set_::countAux(t.Right.clone(), acc + 1i32))
                }
            }
            _ => acc,
        }
    }
    pub fn count<_a: Clone + 'static>(s: Set_::Set<_a>) -> i32 {
        Set_::countAux(s, 0i32)
    }
    pub fn mk<T: Clone + 'static>(l: Set_::Set<T>, k: T, r: Set_::Set<T>) -> Set_::Set<T> {
        let hl: i32 = {
            let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = l.root.clone();
            match &matchValue {
                Some(matchValue_0_0) => (matchValue_0_0).Height,
                _ => 0i32,
            }
        };
        let hr: i32 = {
            let matchValue_1: Option<Lrc<Set_::SetTree_1<T>>> = r.root.clone();
            match &matchValue_1 {
                Some(matchValue_1_0_0) => (matchValue_1_0_0).Height,
                _ => 0i32,
            }
        };
        let m: i32 = if hl < hr { hr } else { hl };
        if m == 0i32 {
            Set_::mkSetTreeLeaf(k.clone())
        } else {
            Set_::mkSetTreeNode(k, l, r, m + 1i32)
        }
    }
    pub fn rebalance<T: Clone + 'static>(t1: Set_::Set<T>, v: T, t2: Set_::Set<T>) -> Set_::Set<T> {
        let t1h: i32 = {
            let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = t1.root.clone();
            match &matchValue {
                Some(matchValue_0_0) => (matchValue_0_0).Height,
                _ => 0i32,
            }
        };
        let t2h: i32 = {
            let matchValue_1: Option<Lrc<Set_::SetTree_1<T>>> = t2.root.clone();
            match &matchValue_1 {
                Some(matchValue_1_0_0) => (matchValue_1_0_0).Height,
                _ => 0i32,
            }
        };
        if t2h > t1h + 2i32 {
            let t2_: Lrc<Set_::SetTree_1<T>> = getValue(t2.root.clone()).clone();
            if {
                let matchValue_2: Option<Lrc<Set_::SetTree_1<T>>> = (t2_.Left).root.clone();
                match &matchValue_2 {
                    Some(matchValue_2_0_0) => (matchValue_2_0_0).Height,
                    _ => 0i32,
                }
            } > t1h + 1i32
            {
                let t2l: Lrc<Set_::SetTree_1<T>> = getValue((t2_.Left).root.clone()).clone();
                Set_::mk(
                    Set_::mk(t1.clone(), v.clone(), t2l.Left.clone()),
                    t2l.Key.clone(),
                    Set_::mk(t2l.Right.clone(), t2_.Key.clone(), t2_.Right.clone()),
                )
            } else {
                Set_::mk(
                    Set_::mk(t1.clone(), v.clone(), t2_.Left.clone()),
                    t2_.Key.clone(),
                    t2_.Right.clone(),
                )
            }
        } else {
            if t1h > t2h + 2i32 {
                let t1_: Lrc<Set_::SetTree_1<T>> = getValue(t1.root.clone()).clone();
                if {
                    let matchValue_3: Option<Lrc<Set_::SetTree_1<T>>> = (t1_.Right).root.clone();
                    match &matchValue_3 {
                        Some(matchValue_3_0_0) => (matchValue_3_0_0).Height,
                        _ => 0i32,
                    }
                } > t2h + 1i32
                {
                    let t1r: Lrc<Set_::SetTree_1<T>> = getValue((t1_.Right).root.clone()).clone();
                    Set_::mk(
                        Set_::mk(t1_.Left.clone(), t1_.Key.clone(), t1r.Left.clone()),
                        t1r.Key.clone(),
                        Set_::mk(t1r.Right.clone(), v.clone(), t2.clone()),
                    )
                } else {
                    Set_::mk(
                        t1_.Left.clone(),
                        t1_.Key.clone(),
                        Set_::mk(t1_.Right.clone(), v.clone(), t2.clone()),
                    )
                }
            } else {
                Set_::mk(t1, v, t2)
            }
        }
    }
    pub fn add<T: PartialOrd + Clone + 'static>(k: T, s: Set_::Set<T>) -> Set_::Set<T> {
        let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                let c: i32 = compare(k.clone(), t.Key.clone());
                if t.Height == 1i32 {
                    if c < 0i32 {
                        Set_::mkSetTreeNode(k.clone(), Set_::empty(), s.clone(), 2i32)
                    } else {
                        if c == 0i32 {
                            s.clone()
                        } else {
                            Set_::mkSetTreeNode(k.clone(), s.clone(), Set_::empty(), 2i32)
                        }
                    }
                } else {
                    if c < 0i32 {
                        Set_::rebalance(
                            Set_::add(k.clone(), t.Left.clone()),
                            t.Key.clone(),
                            t.Right.clone(),
                        )
                    } else {
                        if c == 0i32 {
                            s
                        } else {
                            Set_::rebalance(
                                t.Left.clone(),
                                t.Key.clone(),
                                Set_::add(k.clone(), t.Right.clone()),
                            )
                        }
                    }
                }
            }
            _ => Set_::mkSetTreeLeaf(k),
        }
    }
    pub fn balance<T: PartialOrd + Clone + 'static>(
        s1: Set_::Set<T>,
        k: T,
        s2: Set_::Set<T>,
    ) -> Set_::Set<T> {
        let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s1.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t1: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                let matchValue_1: Option<Lrc<Set_::SetTree_1<T>>> = s2.root.clone();
                match &matchValue_1 {
                    Some(matchValue_1_0_0) => {
                        let t2: Lrc<Set_::SetTree_1<T>> = matchValue_1_0_0.clone();
                        if t1.Height == 1i32 {
                            Set_::add(k.clone(), Set_::add(t1.Key.clone(), s2.clone()))
                        } else {
                            if t2.Height == 1i32 {
                                Set_::add(k.clone(), Set_::add(t2.Key.clone(), s1.clone()))
                            } else {
                                if t1.Height + 2i32 < t2.Height {
                                    Set_::rebalance(
                                        Set_::balance(s1.clone(), k.clone(), t2.Left.clone()),
                                        t2.Key.clone(),
                                        t2.Right.clone(),
                                    )
                                } else {
                                    if t2.Height + 2i32 < t1.Height {
                                        Set_::rebalance(
                                            t1.Left.clone(),
                                            t1.Key.clone(),
                                            Set_::balance(t1.Right.clone(), k.clone(), s2.clone()),
                                        )
                                    } else {
                                        Set_::mk(s1.clone(), k.clone(), s2.clone())
                                    }
                                }
                            }
                        }
                    }
                    _ => Set_::add(k.clone(), s1),
                }
            }
            _ => Set_::add(k, s2),
        }
    }
    pub fn split<T: PartialOrd + Clone + 'static>(
        pivot: T,
        s: Set_::Set<T>,
    ) -> Lrc<(Set_::Set<T>, bool, Set_::Set<T>)> {
        let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    let c: i32 = compare(t.Key.clone(), pivot.clone());
                    if c < 0i32 {
                        Lrc::new((s.clone(), false, Set_::empty()))
                    } else {
                        if c == 0i32 {
                            Lrc::new((Set_::empty(), true, Set_::empty()))
                        } else {
                            Lrc::new((Set_::empty(), false, s))
                        }
                    }
                } else {
                    let c_1: i32 = compare(pivot.clone(), t.Key.clone());
                    if c_1 < 0i32 {
                        let patternInput: Lrc<(Set_::Set<T>, bool, Set_::Set<T>)> =
                            Set_::split(pivot.clone(), t.Left.clone());
                        Lrc::new((
                            patternInput.0.clone(),
                            patternInput.1.clone(),
                            Set_::balance(patternInput.2.clone(), t.Key.clone(), t.Right.clone()),
                        ))
                    } else {
                        if c_1 == 0i32 {
                            Lrc::new((t.Left.clone(), true, t.Right.clone()))
                        } else {
                            let patternInput_1: Lrc<(Set_::Set<T>, bool, Set_::Set<T>)> =
                                Set_::split(pivot, t.Right.clone());
                            Lrc::new((
                                Set_::balance(
                                    t.Left.clone(),
                                    t.Key.clone(),
                                    patternInput_1.0.clone(),
                                ),
                                patternInput_1.1.clone(),
                                patternInput_1.2.clone(),
                            ))
                        }
                    }
                }
            }
            _ => Lrc::new((Set_::empty(), false, Set_::empty())),
        }
    }
    pub fn spliceOutSuccessor<T: Clone + 'static>(s: Set_::Set<T>) -> Lrc<(T, Set_::Set<T>)> {
        let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    Lrc::new((t.Key.clone(), Set_::empty()))
                } else {
                    if Set_::isEmpty(t.Left.clone()) {
                        Lrc::new((t.Key.clone(), t.Right.clone()))
                    } else {
                        let patternInput: Lrc<(T, Set_::Set<T>)> =
                            Set_::spliceOutSuccessor(t.Left.clone());
                        Lrc::new((
                            patternInput.0.clone(),
                            Set_::mk(patternInput.1.clone(), t.Key.clone(), t.Right.clone()),
                        ))
                    }
                }
            }
            _ => panic!("{}", string("internal error: Set.spliceOutSuccessor")),
        }
    }
    pub fn remove<T: PartialOrd + Clone + 'static>(k: T, s: Set_::Set<T>) -> Set_::Set<T> {
        let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                let c: i32 = compare(k.clone(), t.Key.clone());
                if t.Height == 1i32 {
                    if c == 0i32 {
                        Set_::empty()
                    } else {
                        s.clone()
                    }
                } else {
                    if c < 0i32 {
                        Set_::rebalance(
                            Set_::remove(k.clone(), t.Left.clone()),
                            t.Key.clone(),
                            t.Right.clone(),
                        )
                    } else {
                        if c == 0i32 {
                            if Set_::isEmpty(t.Left.clone()) {
                                t.Right.clone()
                            } else {
                                if Set_::isEmpty(t.Right.clone()) {
                                    t.Left.clone()
                                } else {
                                    let patternInput: Lrc<(T, Set_::Set<T>)> =
                                        Set_::spliceOutSuccessor(t.Right.clone());
                                    Set_::mk(
                                        t.Left.clone(),
                                        patternInput.0.clone(),
                                        patternInput.1.clone(),
                                    )
                                }
                            }
                        } else {
                            Set_::rebalance(
                                t.Left.clone(),
                                t.Key.clone(),
                                Set_::remove(k, t.Right.clone()),
                            )
                        }
                    }
                }
            }
            _ => s,
        }
    }
    pub fn contains<T: PartialOrd + Clone + 'static>(k: T, s: Set_::Set<T>) -> bool {
        let k: MutCell<T> = MutCell::new(k.clone());
        let s: MutCell<Set_::Set<T>> = MutCell::new(s);
        '_contains: loop {
            break '_contains ({
                let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s.root.clone();
                match &matchValue {
                    Some(matchValue_0_0) => {
                        let t: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                        let c: i32 = compare(k.get(), t.Key.clone());
                        if t.Height == 1i32 {
                            c == 0i32
                        } else {
                            if c < 0i32 {
                                let k_temp: T = k.get();
                                let s_temp: Set_::Set<T> = t.Left.clone();
                                k.set(k_temp);
                                s.set(s_temp);
                                continue '_contains;
                            } else {
                                if c == 0i32 {
                                    true
                                } else {
                                    let k_temp: T = k.get();
                                    let s_temp: Set_::Set<T> = t.Right.clone();
                                    k.set(k_temp);
                                    s.set(s_temp);
                                    continue '_contains;
                                }
                            }
                        }
                    }
                    _ => false,
                }
            });
        }
    }
    pub fn iterate<T: Clone + 'static>(f: Lrc<dyn Fn(T) + 'static>, s: Set_::Set<T>) {
        let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    f(t.Key.clone())
                } else {
                    Set_::iterate(f.clone(), t.Left.clone());
                    f(t.Key.clone());
                    Set_::iterate(f, t.Right.clone())
                }
            }
            _ => (),
        }
    }
    pub fn foldBack<T: Clone + 'static, _a: Clone + 'static>(
        f: Lrc<dyn Fn(T, _a) -> (_a) + 'static>,
        s: Set_::Set<T>,
        x: _a,
    ) -> _a {
        let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    f(t.Key.clone(), x.clone())
                } else {
                    Set_::foldBack(
                        f.clone(),
                        t.Left.clone(),
                        f(
                            t.Key.clone(),
                            Set_::foldBack(f.clone(), t.Right.clone(), x.clone()),
                        ),
                    )
                }
            }
            _ => x,
        }
    }
    pub fn fold<_a: Clone + 'static, T: Clone + 'static>(
        f: Lrc<dyn Fn(_a, T) -> (_a) + 'static>,
        x: _a,
        s: Set_::Set<T>,
    ) -> _a {
        let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    f(x.clone(), t.Key.clone())
                } else {
                    Set_::fold(
                        f.clone(),
                        f(
                            Set_::fold(f.clone(), x.clone(), t.Left.clone()),
                            t.Key.clone(),
                        ),
                        t.Right.clone(),
                    )
                }
            }
            _ => x,
        }
    }
    pub fn map<T: Clone + 'static, _a: PartialOrd + Clone + 'static>(
        mapping: Lrc<dyn Fn(T) -> (_a) + 'static>,
        s: Set_::Set<T>,
    ) -> Set_::Set<_a> {
        Set_::fold(
            Lrc::new({
                let mapping = mapping.clone();
                move |acc: Set_::Set<_a>, k: T| Set_::add(mapping(k.clone()), acc.clone())
            }),
            Set_::empty(),
            s,
        )
    }
    pub fn forAll<T: Clone + 'static>(
        f: Lrc<dyn Fn(T) -> (bool) + 'static>,
        s: Set_::Set<T>,
    ) -> bool {
        let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    f(t.Key.clone())
                } else {
                    if if f(t.Key.clone()) {
                        Set_::forAll(f.clone(), t.Left.clone())
                    } else {
                        false
                    } {
                        Set_::forAll(f, t.Right.clone())
                    } else {
                        false
                    }
                }
            }
            _ => true,
        }
    }
    pub fn exists<T: Clone + 'static>(
        f: Lrc<dyn Fn(T) -> (bool) + 'static>,
        s: Set_::Set<T>,
    ) -> bool {
        let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    f(t.Key.clone())
                } else {
                    if if f(t.Key.clone()) {
                        true
                    } else {
                        Set_::exists(f.clone(), t.Left.clone())
                    } {
                        true
                    } else {
                        Set_::exists(f, t.Right.clone())
                    }
                }
            }
            _ => false,
        }
    }
    pub fn isSubset<_a: PartialOrd + Clone + 'static>(a: Set_::Set<_a>, b: Set_::Set<_a>) -> bool {
        Set_::forAll(
            Lrc::new({
                let b = b.clone();
                move |x: _a| Set_::contains(x.clone(), b.clone())
            }),
            a,
        )
    }
    pub fn isSuperset<_a: PartialOrd + Clone + 'static>(
        a: Set_::Set<_a>,
        b: Set_::Set<_a>,
    ) -> bool {
        Set_::isSubset(b, a)
    }
    pub fn isProperSubset<_a: PartialOrd + Clone + 'static>(
        a: Set_::Set<_a>,
        b: Set_::Set<_a>,
    ) -> bool {
        if Set_::forAll(
            Lrc::new({
                let b = b.clone();
                move |x: _a| Set_::contains(x.clone(), b.clone())
            }),
            a.clone(),
        ) {
            Set_::exists(
                Lrc::new({
                    let a = a.clone();
                    move |x_1: _a| !Set_::contains(x_1.clone(), a.clone())
                }),
                b.clone(),
            )
        } else {
            false
        }
    }
    pub fn isProperSuperset<_a: PartialOrd + Clone + 'static>(
        a: Set_::Set<_a>,
        b: Set_::Set<_a>,
    ) -> bool {
        Set_::isProperSubset(b, a)
    }
    pub fn filterAux<T: PartialOrd + Clone + 'static>(
        f: Lrc<dyn Fn(T) -> (bool) + 'static>,
        s: Set_::Set<T>,
        acc: Set_::Set<T>,
    ) -> Set_::Set<T> {
        let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    if f(t.Key.clone()) {
                        Set_::add(t.Key.clone(), acc.clone())
                    } else {
                        acc.clone()
                    }
                } else {
                    Set_::filterAux(
                        f.clone(),
                        t.Left.clone(),
                        Set_::filterAux(
                            f.clone(),
                            t.Right.clone(),
                            if f(t.Key.clone()) {
                                Set_::add(t.Key.clone(), acc.clone())
                            } else {
                                acc.clone()
                            },
                        ),
                    )
                }
            }
            _ => acc,
        }
    }
    pub fn filter<_a: PartialOrd + Clone + 'static>(
        f: Lrc<dyn Fn(_a) -> (bool) + 'static>,
        s: Set_::Set<_a>,
    ) -> Set_::Set<_a> {
        Set_::filterAux(f, s, Set_::empty())
    }
    pub fn diffAux<T: PartialOrd + Clone + 'static>(
        s: Set_::Set<T>,
        acc: Set_::Set<T>,
    ) -> Set_::Set<T> {
        let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = acc.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let _acc: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                let matchValue_1: Option<Lrc<Set_::SetTree_1<T>>> = s.root.clone();
                match &matchValue_1 {
                    Some(matchValue_1_0_0) => {
                        let t: Lrc<Set_::SetTree_1<T>> = matchValue_1_0_0.clone();
                        if t.Height == 1i32 {
                            Set_::remove(t.Key.clone(), acc.clone())
                        } else {
                            Set_::diffAux(
                                t.Left.clone(),
                                Set_::diffAux(
                                    t.Right.clone(),
                                    Set_::remove(t.Key.clone(), acc.clone()),
                                ),
                            )
                        }
                    }
                    _ => acc.clone(),
                }
            }
            _ => acc,
        }
    }
    pub fn difference<_a: PartialOrd + Clone + 'static>(
        a: Set_::Set<_a>,
        b: Set_::Set<_a>,
    ) -> Set_::Set<_a> {
        Set_::diffAux(b, a)
    }
    pub fn r#union<T: PartialOrd + Clone + 'static>(
        s1: Set_::Set<T>,
        s2: Set_::Set<T>,
    ) -> Set_::Set<T> {
        let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s1.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t1: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                let matchValue_1: Option<Lrc<Set_::SetTree_1<T>>> = s2.root.clone();
                match &matchValue_1 {
                    Some(matchValue_1_0_0) => {
                        let t2: Lrc<Set_::SetTree_1<T>> = matchValue_1_0_0.clone();
                        if t1.Height == 1i32 {
                            Set_::add(t1.Key.clone(), s2.clone())
                        } else {
                            if t2.Height == 1i32 {
                                Set_::add(t2.Key.clone(), s1.clone())
                            } else {
                                if t1.Height > t2.Height {
                                    let patternInput: Lrc<(Set_::Set<T>, bool, Set_::Set<T>)> =
                                        Set_::split(t1.Key.clone(), s2.clone());
                                    Set_::balance(
                                        Set_::r#union(t1.Left.clone(), patternInput.0.clone()),
                                        t1.Key.clone(),
                                        Set_::r#union(t1.Right.clone(), patternInput.2.clone()),
                                    )
                                } else {
                                    let patternInput_1: Lrc<(Set_::Set<T>, bool, Set_::Set<T>)> =
                                        Set_::split(t2.Key.clone(), s1.clone());
                                    Set_::balance(
                                        Set_::r#union(t2.Left.clone(), patternInput_1.0.clone()),
                                        t2.Key.clone(),
                                        Set_::r#union(t2.Right.clone(), patternInput_1.2.clone()),
                                    )
                                }
                            }
                        }
                    }
                    _ => s1,
                }
            }
            _ => s2,
        }
    }
    pub fn unionMany<T: PartialOrd + Clone + 'static>(
        sets: Lrc<dyn IEnumerable_1<Set_::Set<T>>>,
    ) -> Set_::Set<T> {
        fold_1(
            Lrc::new(move |s: Set_::Set<T>, s_1: Set_::Set<T>| {
                Set_::r#union(s.clone(), s_1.clone())
            }),
            Set_::empty(),
            sets,
        )
    }
    pub fn intersectionAux<T: PartialOrd + Clone + 'static>(
        b: Set_::Set<T>,
        s: Set_::Set<T>,
        acc: Set_::Set<T>,
    ) -> Set_::Set<T> {
        let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    if Set_::contains(t.Key.clone(), b.clone()) {
                        Set_::add(t.Key.clone(), acc.clone())
                    } else {
                        acc.clone()
                    }
                } else {
                    let acc_1: Set_::Set<T> =
                        Set_::intersectionAux(b.clone(), t.Right.clone(), acc.clone());
                    Set_::intersectionAux(
                        b.clone(),
                        t.Left.clone(),
                        if Set_::contains(t.Key.clone(), b) {
                            Set_::add(t.Key.clone(), acc_1.clone())
                        } else {
                            acc_1
                        },
                    )
                }
            }
            _ => acc,
        }
    }
    pub fn intersect<_a: PartialOrd + Clone + 'static>(
        a: Set_::Set<_a>,
        b: Set_::Set<_a>,
    ) -> Set_::Set<_a> {
        if Set_::isEmpty(b.clone()) {
            b.clone()
        } else {
            Set_::intersectionAux(b, a, Set_::empty())
        }
    }
    pub fn intersectMany<T: PartialOrd + Clone + 'static>(
        sets: Lrc<dyn IEnumerable_1<Set_::Set<T>>>,
    ) -> Set_::Set<T> {
        reduce(
            Lrc::new(move |a: Set_::Set<T>, b: Set_::Set<T>| Set_::intersect(a.clone(), b.clone())),
            sets,
        )
    }
    pub fn partition1<_a: PartialOrd + Clone + 'static>(
        f: Lrc<dyn Fn(_a) -> (bool) + 'static>,
        k: _a,
        acc1: Set_::Set<_a>,
        acc2: Set_::Set<_a>,
    ) -> Lrc<(Set_::Set<_a>, Set_::Set<_a>)> {
        if f(k.clone()) {
            Lrc::new((Set_::add(k.clone(), acc1.clone()), acc2.clone()))
        } else {
            Lrc::new((acc1, Set_::add(k, acc2)))
        }
    }
    pub fn partitionAux<T: PartialOrd + Clone + 'static>(
        f: Lrc<dyn Fn(T) -> (bool) + 'static>,
        s: Set_::Set<T>,
        acc_: Set_::Set<T>,
        acc__1: Set_::Set<T>,
    ) -> Lrc<(Set_::Set<T>, Set_::Set<T>)> {
        let acc: Lrc<(Set_::Set<T>, Set_::Set<T>)> = Lrc::new((acc_, acc__1));
        let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    Set_::partition1(f.clone(), t.Key.clone(), acc.0.clone(), acc.1.clone())
                } else {
                    let acc_3: Lrc<(Set_::Set<T>, Set_::Set<T>)> = Set_::partitionAux(
                        f.clone(),
                        t.Right.clone(),
                        acc.0.clone(),
                        acc.1.clone(),
                    );
                    let acc_6: Lrc<(Set_::Set<T>, Set_::Set<T>)> = Set_::partition1(
                        f.clone(),
                        t.Key.clone(),
                        acc_3.0.clone(),
                        acc_3.1.clone(),
                    );
                    Set_::partitionAux(f, t.Left.clone(), acc_6.0.clone(), acc_6.1.clone())
                }
            }
            _ => acc,
        }
    }
    pub fn partition<_a: PartialOrd + Clone + 'static>(
        f: Lrc<dyn Fn(_a) -> (bool) + 'static>,
        s: Set_::Set<_a>,
    ) -> Lrc<(Set_::Set<_a>, Set_::Set<_a>)> {
        Set_::partitionAux(f, s, Set_::empty(), Set_::empty())
    }
    pub fn minimumElementAux<T: Clone + 'static>(s: Set_::Set<T>, n: T) -> T {
        let s: MutCell<Set_::Set<T>> = MutCell::new(s);
        let n: MutCell<T> = MutCell::new(n);
        '_minimumElementAux: loop {
            break '_minimumElementAux ({
                let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s.root.clone();
                match &matchValue {
                    Some(matchValue_0_0) => {
                        let t: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                        if t.Height == 1i32 {
                            t.Key.clone()
                        } else {
                            let s_temp: Set_::Set<T> = t.Left.clone();
                            let n_temp: T = t.Key.clone();
                            s.set(s_temp);
                            n.set(n_temp);
                            continue '_minimumElementAux;
                        }
                    }
                    _ => n.get(),
                }
            });
        }
    }
    pub fn minimumElementOpt<T: Clone + 'static>(s: Set_::Set<T>) -> Option<T> {
        let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    Some(t.Key.clone())
                } else {
                    Some(Set_::minimumElementAux(t.Left.clone(), t.Key.clone()))
                }
            }
            _ => None::<T>,
        }
    }
    pub fn maximumElementAux<T: Clone + 'static>(s: Set_::Set<T>, n: T) -> T {
        let s: MutCell<Set_::Set<T>> = MutCell::new(s);
        let n: MutCell<T> = MutCell::new(n);
        '_maximumElementAux: loop {
            break '_maximumElementAux ({
                let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s.root.clone();
                match &matchValue {
                    Some(matchValue_0_0) => {
                        let t: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                        if t.Height == 1i32 {
                            t.Key.clone()
                        } else {
                            let s_temp: Set_::Set<T> = t.Right.clone();
                            let n_temp: T = t.Key.clone();
                            s.set(s_temp);
                            n.set(n_temp);
                            continue '_maximumElementAux;
                        }
                    }
                    _ => n.get(),
                }
            });
        }
    }
    pub fn maximumElementOpt<T: Clone + 'static>(s: Set_::Set<T>) -> Option<T> {
        let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = s.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    Some(t.Key.clone())
                } else {
                    Some(Set_::maximumElementAux(t.Right.clone(), t.Key.clone()))
                }
            }
            _ => None::<T>,
        }
    }
    pub fn minElement<_a: Clone + 'static>(s: Set_::Set<_a>) -> _a {
        let matchValue: Option<_a> = Set_::minimumElementOpt(s);
        match &matchValue {
            None => panic!(
                "{}",
                append(
                    append(SR::setContainsNoElements(), string("\\nParameter name: ")),
                    string("s")
                )
            ),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn maxElement<_a: Clone + 'static>(s: Set_::Set<_a>) -> _a {
        let matchValue: Option<_a> = Set_::maximumElementOpt(s);
        match &matchValue {
            None => panic!(
                "{}",
                append(
                    append(SR::setContainsNoElements(), string("\\nParameter name: ")),
                    string("s")
                )
            ),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    #[derive(Clone, Debug, Default, Hash)]
    pub struct SetIterator_1<T: PartialOrd + Clone + 'static> {
        pub stack: MutCell<List<Set_::Set<T>>>,
        pub started: MutCell<bool>,
    }
    pub fn collapseLHS<T: Clone + 'static>(stack: List<Set_::Set<T>>) -> List<Set_::Set<T>> {
        let stack: MutCell<List<Set_::Set<T>>> = MutCell::new(stack.clone());
        '_collapseLHS: loop {
            break '_collapseLHS (if !isEmpty_1(stack.get()) {
                let rest: List<Set_::Set<T>> = tail(stack.get()).clone();
                let matchValue: Option<Lrc<Set_::SetTree_1<T>>> = (head(stack.get())).root.clone();
                match &matchValue {
                    Some(matchValue_0_0) => {
                        let t: Lrc<Set_::SetTree_1<T>> = matchValue_0_0.clone();
                        if t.Height == 1i32 {
                            stack.get()
                        } else {
                            let stack_temp: List<Set_::Set<T>> = cons(
                                t.Left.clone(),
                                cons(
                                    Set_::mkSetTreeLeaf(t.Key.clone()),
                                    cons(t.Right.clone(), rest),
                                ),
                            );
                            stack.set(stack_temp);
                            continue '_collapseLHS;
                        }
                    }
                    _ => {
                        let stack_temp: List<Set_::Set<T>> = rest;
                        stack.set(stack_temp);
                        continue '_collapseLHS;
                    }
                }
            } else {
                empty_1::<Set_::Set<T>>()
            });
        }
    }
    pub fn mkIterator<_a: PartialOrd + Clone + 'static>(
        s: Set_::Set<_a>,
    ) -> Lrc<Set_::SetIterator_1<_a>> {
        Lrc::new(Set_::SetIterator_1::<_a> {
            stack: MutCell::new(Set_::collapseLHS(singleton_1(s))),
            started: MutCell::new(false),
        })
    }
    pub fn notStarted<_a: Clone + 'static>() -> _a {
        panic!("{}", SR::enumerationNotStarted())
    }
    pub fn alreadyFinished<_a: Clone + 'static>() -> _a {
        panic!("{}", SR::enumerationAlreadyFinished())
    }
    pub fn current<T: PartialOrd + Clone + 'static>(i: Lrc<Set_::SetIterator_1<T>>) -> T {
        if i.started.get() {
            let matchValue: List<Set_::Set<T>> = i.stack.get().clone();
            if !isEmpty_1(matchValue.clone()) {
                if (head(matchValue.clone())).root.is_some() {
                    let k: Lrc<Set_::SetTree_1<T>> =
                        getValue((head(matchValue.clone())).root.clone()).clone();
                    k.Key.clone()
                } else {
                    Set_::alreadyFinished()
                }
            } else {
                Set_::alreadyFinished()
            }
        } else {
            Set_::notStarted()
        }
    }
    pub fn unexpectedStackForMoveNext<_a: Clone + 'static>() -> _a {
        panic!(
            "{}",
            string("Please report error: Set iterator, unexpected stack for moveNext")
        )
    }
    pub fn unexpectedstateInSetTreeCompareStacks<_a: Clone + 'static>() -> _a {
        panic!("{}", string("unexpected state in SetTree.compareStacks"))
    }
    pub fn moveNext<T: PartialOrd + Clone + 'static>(i: Lrc<Set_::SetIterator_1<T>>) -> bool {
        if i.started.get() {
            let matchValue: List<Set_::Set<T>> = i.stack.get().clone();
            if !isEmpty_1(matchValue.clone()) {
                if (head(matchValue.clone())).root.is_some() {
                    let t: Lrc<Set_::SetTree_1<T>> =
                        getValue((head(matchValue.clone())).root.clone()).clone();
                    if t.Height == 1i32 {
                        i.stack
                            .set(Set_::collapseLHS(tail(matchValue.clone()).clone()));
                        !isEmpty_1(i.stack.get().clone())
                    } else {
                        Set_::unexpectedStackForMoveNext()
                    }
                } else {
                    false
                }
            } else {
                false
            }
        } else {
            i.started.set(true);
            !isEmpty_1(i.stack.get().clone())
        }
    }
    pub fn choose<_a: Clone + 'static>(s: Set_::Set<_a>) -> _a {
        Set_::minElement(s)
    }
    pub fn copyToArray<_a: Clone + 'static>(s: Set_::Set<_a>, arr: Array<_a>, i: i32) {
        let j: Lrc<MutCell<i32>> = Lrc::new(MutCell::new(i));
        Set_::iterate(
            Lrc::new({
                let arr = arr.clone();
                let j = j.clone();
                move |x: _a| {
                    arr.get_mut()[j.get() as usize] = x.clone();
                    j.set(j.get() + 1i32)
                }
            }),
            s,
        )
    }
    pub fn toArray<T: Clone + 'static>(s: Set_::Set<T>) -> Array<T> {
        let res: Array<T> = arrayWithCapacity::<T>(Set_::count(s.clone()));
        Set_::iterate(
            Lrc::new({
                let res = res.clone();
                move |x: T| res.get_mut().push(x.clone())
            }),
            s,
        );
        (&res).clone()
    }
    pub fn toList<T: Clone + 'static>(s: Set_::Set<T>) -> List<T> {
        Set_::foldBack(
            Lrc::new(move |k: T, acc: List<T>| cons(k.clone(), acc.clone())),
            s,
            empty_1::<T>(),
        )
    }
    pub fn ofArray<_a: PartialOrd + Clone + 'static>(xs: Array<_a>) -> Set_::Set<_a> {
        fold_2(
            Lrc::new(move |acc: Set_::Set<_a>, k: _a| Set_::add(k.clone(), acc.clone())),
            Set_::empty(),
            xs,
        )
    }
    pub fn ofList<_a: PartialOrd + Clone + 'static>(xs: List<_a>) -> Set_::Set<_a> {
        fold_3(
            Lrc::new(move |acc: Set_::Set<_a>, k: _a| Set_::add(k.clone(), acc.clone())),
            Set_::empty(),
            xs,
        )
    }
    pub fn ofSeq<_a: PartialOrd + Clone + 'static>(
        xs: Lrc<dyn IEnumerable_1<_a>>,
    ) -> Set_::Set<_a> {
        fold_1(
            Lrc::new(move |acc: Set_::Set<_a>, k: _a| Set_::add(k.clone(), acc.clone())),
            Set_::empty(),
            xs,
        )
    }
    pub fn toSeq<T: PartialOrd + Clone + 'static>(s: Set_::Set<T>) -> Lrc<dyn IEnumerable_1<T>> {
        delay(Lrc::new({
            let s = s.clone();
            move || {
                unfold(
                    Lrc::new(move |i: Lrc<Set_::SetIterator_1<T>>| {
                        if Set_::moveNext(i.clone()) {
                            Some(Lrc::new((Set_::current(i.clone()), i.clone())))
                        } else {
                            None::<Lrc<(T, Lrc<Set_::SetIterator_1<T>>)>>
                        }
                    }),
                    Set_::mkIterator(s.clone()),
                )
            }
        }))
    }
    pub fn compareTo<T: PartialOrd + Clone + 'static>(s1: Set_::Set<T>, s2: Set_::Set<T>) -> i32 {
        compareWith(
            Lrc::new(move |e: T, e_1: T| compare(e.clone(), e_1.clone())),
            Set_::toSeq(s1),
            Set_::toSeq(s2),
        )
    }
    pub fn equals<T: PartialOrd + Clone + 'static>(s1: Set_::Set<T>, s2: Set_::Set<T>) -> bool {
        Set_::compareTo(s1, s2) == 0i32
    }
}
