pub mod Util_ {
    use super::*;
    use crate::module_2031347a::Native_::MutCell;
    pub fn equals<T: Eq + core::hash::Hash + Clone + 'static>(x: T, y: T) -> bool {
        x == y
    }
    pub fn compare<T: PartialOrd + Clone + 'static>(x: T, y: T) -> i32 {
        if x.clone() > y.clone() {
            1i32
        } else {
            if x < y {
                -1i32
            } else {
                0i32
            }
        }
    }
    pub fn ignore<T: Clone + 'static>(x: T) {
        ();
    }
    pub fn divRem<T: core::ops::Div<Output = T> + core::ops::Rem<Output = T> + Clone + 'static>(
        x: T,
        y: T,
    ) -> (T, T) {
        (x.clone() / y.clone(), x % y)
    }
    pub fn divRemOut<
        T: core::ops::Div<Output = T> + core::ops::Rem<Output = T> + Clone + 'static,
    >(
        x: T,
        y: T,
        remainder: &MutCell<T>,
    ) -> T {
        let quotient: T = x.clone() / y.clone();
        remainder.set(x.clone() % y.clone());
        quotient
    }
}
